EXPECT_FAIL_TEXT = {
    "precondition_text": {
        "en": "Precondition applied",
        "fr": "Condition préalable",
        "de": "Voraussetzung angewandt",
        "it": "Prerequisito applicato",
        "es": "Condición previa aplicada",
        "pt": "Pré-condição aplicada",
        "ro": "Precondiție aplicată",
        "tr": "Ön koşul uygulandı",
        "zh-Hans": "应用先决条件",
        "zh-Hant": "應用先決條件",
        "ja": "前提条件が適用されました",
        "ko": "전제 조건 적용됨",
        "vi": "Điều kiện tiên quyết đã được áp dụng",
        "ru": "Применяемое предварительное условие",
        "cs": "Aplikována vstupní podmínka",
        "pl": "Zastosowano warunek wstępny",
        "da": "Forudsætning anvendt",
        "sv": "Antagande används",
        "nb": "Forutsetning anvendt",
        "nl": "Voorwaarde toegepast",
        "fi": "Esiehto sovellettu",
        "is": "Forskilyrði beitt",
        "ar": "تم تطبيق الشرط المسبق",
        "hi": "पूर्व शर्त लागू की गई",
        "el": "Εφαρμόστηκε προϋπόθεση",
    },
    "column_computed_text": {
        "en": "computed column",
        "fr": "colonne calculée",
        "de": "berechnete Spalte",
        "it": "colonna calcolata",
        "es": "columna calculada",
        "pt": "coluna calculada",
        "ro": "coloană calculată",
        "tr": "hesaplanmış sütun",
        "zh-Hans": "计算后的列",
        "zh-Hant": "計算後的列",
        "ja": "計算された列",
        "ko": "계산된 열",
        "vi": "cột được tính toán",
        "ru": "Вычисленный столбец",
        "cs": "vypočtený sloupec",
        "pl": "kolumna obliczeniowa",
        "da": "beregnet kolonne",
        "sv": "beräknad kolumn",
        "nb": "beregnet kolonne",
        "nl": "berekende kolom",
        "fi": "laskettu sarake",
        "is": "reiknaður dálkur",
        "ar": "عمود محسوب",
        "hi": "परिकलित स्तंभ",
        "el": "υπολογισμένη στήλη",
    },
    "values_text": {
        "en": "and {num_omitted} more",
        "fr": "et {num_omitted} de plus",
        "de": "und {num_omitted} mehr",
        "it": "e altri {num_omitted}",
        "es": "y {num_omitted} más",
        "pt": "e {num_omitted} mais",
        "ro": "și încă {num_omitted}",
        "tr": "ve {num_omitted} tane daha",
        "zh-Hans": "还有{num_omitted}个",
        "zh-Hant": "還有{num_omitted}個",
        "ja": "他に{num_omitted}個",
        "ko": "외 {num_omitted}개",
        "vi": "và {num_omitted} khác",
        "ru": "И {num_omitted} больше",
        "cs": "a {num_omitted} dalších",
        "pl": "i jeszcze {num_omitted}",
        "da": "og {num_omitted} flere",
        "sv": "och {num_omitted} till",
        "nb": "og {num_omitted} flere",
        "nl": "en {num_omitted} meer",
        "fi": "ja {num_omitted} lisää",
        "is": "og {num_omitted} fleiri",
        "ar": "و{num_omitted} أكثر",
        "hi": "और {num_omitted} अधिक",
        "el": "και {num_omitted} περισσότερα",
    },
    "compare_expectation_text": {
        "en": "Expect that values in {column_text} should be {operator} {values_text}.",
        "fr": "On s'attend à ce que les valeurs de {column_text} soient {operator} {values_text}.",
        "de": "Erwarten Sie, dass die Werte in {column_text} {operator} {values_text} sein sollten.",
        "it": "Aspettatevi che i valori in {column_text} dovrebbero essere {operator} {values_text}.",
        "es": "Se espera que los valores en {column_text} sean {operator} {values_text}.",
        "pt": "Espera-se que os valores em {column_text} são {operator} {values_text}.",
        "ro": "Se așteaptă ca valorile din {column_text} să fie {operator} {values_text}.",
        "tr": "Beklenti, {column_text} 'deki değerlerin {operator} {values_text} olması gerektiğidir.",
        "zh-Hans": "预期在{column_text} 的值应当{operator} {values_text}。",
        "zh-Hant": "{column_text}之值應{operator} {values_text}。",
        "ja": "{column_text}の値が{operator} {values_text}であることを期待します。",
        "ko": "{column_text}의 값이 {operator} {values_text}이어야 합니다.",
        "vi": "Kỳ vọng các giá trị trong {column_text} phải {operator} {values_text}.",
        "ru": "Ожидайте, что значения в {column_text} должны быть {operator} {values_text}.",
        "cs": "Očekává se, že hodnoty ve sloupci {column_text} budou {operator} {values_text}.",
        "pl": "Spodziewaj się, że wartości w {column_text} powinny wynosic {operator} {values_text}.",
        "da": "Forvent at værdier i {column_text} er {operator} {values_text}.",
        "sv": "Förvänta dig att värden i {column_text} är {operator} {values_text}.",
        "nb": "Forvent at verdier i {column_text} skal være {operator} {values_text}.",
        "nl": "Verwacht dat waarden in {column_text} {operator} {values_text} moeten zijn.",
        "fi": "Odota, että arvot sarakkeessa {column_text} ovat {operator} {values_text}.",
        "is": "Væntir þess að gildi í {column_text} séu {operator} {values_text}.",
        "ar": "توقع أن القيم في {column_text} تحقق الشرط التالي: ({operator} {values_text})",
        "hi": "अपेक्षा है कि {column_text} में मान {operator} {values_text} होने चाहिए।",
        "el": "Αναμένεται οι τιμές στη στήλη {column_text} να είναι {operator} {values_text}.",
    },
    "compare_failure_text": {
        "en": "Exceedance of failed test units where values in {column_text} should have been {operator} {values_text}.",
        "fr": "Dépassement des unités de test ayant échoué où les valeurs dans {column_text} auraient dû être {operator} {values_text}.",
        "de": "Überschreitung fehlgeschlagener Testeinheiten, bei denen die Werte in {column_text} {operator} {values_text} sein sollten.",
        "it": "Superamento delle unità di test non riuscite in cui i valori in {column_text} avrebbero dovuto essere {operator} {values_text}.",
        "es": "Se superó el número de unidades de prueba fallidas en que los valores en {column_text} deberían haber sido {operator} {values_text}.",
        "pt": "Excedeu o número de unidades de teste com falha onde os valores em {column_text} deveria ter sido {operator} {values_text}.",
        "ro": "Depășirea unităților de test eșuate unde valorile din {column_text} ar fi trebuit să fie {operator} {values_text}.",
        "tr": "{column_text} 'deki değerlerin {operator} {values_text} olması gereken başarısız test birimlerinin aşılması.",
        "zh-Hans": "错误过多，其中{column_text}中的值应当被 {operator} {values_text}。",
        "zh-Hant": "錯誤過多，{column_text}之值應{operator} {values_text}。",
        "ja": "{column_text}の値が{operator} {values_text}であるべきテスト単位の失敗の超過。",
        "ko": "{column_text}의 값이 {operator} {values_text}이어야 했던 실패한 테스트 단위 초과.",
        "vi": "Vượt quá số đơn vị kiểm tra thất bại trong đó các giá trị trong {column_text} đáng lẽ phải {operator} {values_text}.",
        "ru": "Превышение неудачных тестовых единиц, где значения в {column_text} должны были быть {operator} {values_text}.",
        "cs": "Překročení počtu neúspěšných testů, kde hodnoty ve sloupci {column_text} měly být {operator} {values_text}.",
        "pl": "Nie było przekroczenie nieudanych jednostek testujacych, gdzie wartości w {column_text} powinien byc {operator} {values_text}.",
        "da": "Overskridelse af fejlslagne test enheder hvor værdier i {column_text} skulle have været {operator} {values_text}.",
        "sv": "Överskrider misslyckade testenheter där värden i {column_text} borde ha varit {operator} {values_text}.",
        "nb": "Overskridelse av mislykkede testenheter hvor verdier i {column_text} skulle ha vært {operator} {values_text}.",
        "nl": "Overschrijding van mislukte testeenheden, waar de waarden in {column_text} {operator} {values_text} zouden moeten zijn.",
        "fi": "Epäonnistuneiden testiyksikköjen ylitys, joissa sarakkeen {column_text} arvojen olisi pitänyt olla {operator} {values_text}.",
        "is": "Of mörg misheppnuð próf þar sem gildi í {column_text} hefðu átt að vera {operator} {values_text}.",
        "ar": "تجاوز وحدات الاختبار الفاشلة حيث كان يجب أن تحقق القيم في {column_text} الشرط التالي: ({operator} {values_text})",
        "hi": "{column_text} में मान {operator} {values_text} होने चाहिए थे, ऐसे असफल परीक्षण इकाइयों की अधिकता।",
        "el": "Υπέρβαση αποτυχημένων μονάδων δοκιμής όπου οι τιμές στη στήλη {column_text} θα έπρεπε να ήταν {operator} {values_text}.",
    },
    "in_set_expectation_text": {
        "en": "Expect that values in {column_text} should be in the set of {values_text}.",
        "fr": "On s'attend à ce que les valeurs de {column_text} soient une des valeurs suivantes :{values_text}.",
        "de": "Erwarten Sie, dass die Werte in {column_text} in der Menge von {values_text} enthalten sein sollten.",
        "it": "Aspettatevi che i valori in {column_text} siano nell'insieme di {values_text}.",
        "es": "Se espera que los valores en {column_text} estén en el conjunto de {values_text}.",
        "pt": "Espera-se que os valores em {column_text} devem estar no conjunto de {values_text}.",
        "ro": "Se așteaptă ca valorile din {column_text} să fie în setul {values_text}.",
        "tr": "Beklenti, {column_text} 'deki değerlerin {values_text} kümesinde olması gerektiğidir.",
        "zh-Hans": "预期在{column_text} 的值应当在集{values_text}中。",
        "zh-Hant": "{column_text}之值應該在{values_text}集合中。",
        "ja": "{column_text}の値が{values_text}の集合に含まれていることを期待します。",
        "ko": "{column_text}의 값이 {values_text} 집합에 포함되어야 합니다.",
        "vi": "Kỳ vọng các giá trị trong {column_text} phải nằm trong tập hợp {values_text}.",
        "ru": "Ожидайте, что значения в {column_text} должны быть в наборе {values_text}.",
        "cs": "Očekává se, že hodnoty ve sloupci {column_text} budou v množině {values_text}.",
        "pl": "Spodziewaj się, że wartości w {column_text} powinny byc w zestawie {values_text}.",
        "da": "Forvent at værdier i {column_text} findes blandt {values_text}.",
        "sv": "Förvänta dig att värden i {column_text} finns bland {values_text}.",
        "nb": "Forvent at verdier i {column_text} skal være i settet av {values_text}.",
        "nl": "Verwacht dat de waarden in {column_text} in de set {values_text} moeten staan.",
        "fi": "Odota, että arvot sarakkeessa {column_text} kuuluvat joukkoon {values_text}.",
        "is": "Væntir þess að gildi í {column_text} séu í mengi {values_text}.",
        "ar": "تجاوز وحدات الاختبار الفاشلة حيث كان يجب أن تكون القيم في {column_text} ضمن مجموعة {values_text}.",
        "hi": "अपेक्षा है कि {column_text} में मान {values_text} समूह में होने चाहिए।",
        "el": "Αναμένεται οι τιμές στη στήλη {column_text} να ανήκουν στο σύνολο {values_text}.",
    },
    "in_set_failure_text": {
        "en": "Exceedance of failed test units where values in {column_text} should have been in the set of {values_text}.",
        "fr": "Dépassement des unités de test ayant échoué où les valeurs dans {column_text} auraient dû être une des valeurs suivantes : {values_text}.",
        "de": "Überschreitung fehlgeschlagener Testeinheiten, bei denen Werte in {column_text} in der Menge von {values_text} enthalten sein sollten.",
        "it": "Superamento delle unità di test non riuscite in cui i valori in {column_text} avrebbero dovuto essere nel set di {values_text}.",
        "es": "Se superó el número de unidades de prueba fallidas donde los valores en {column_text} deberían haber estado en el conjunto de {values_text}.",
        "pt": "Excedeu o número de unidades de teste com falha onde os valores em {column_text} deveria ter sido no conjunto de {values_text}.",
        "ro": "Depășirea unităților de test eșuate unde valorile din {column_text} ar fi trebuit să fie în setul {values_text}.",
        "tr": "{column_text} 'deki değerlerin {values_text} kümesinde olması gereken başarısız test birimlerinin aşılması.",
        "zh-Hans": "错误过多，其中{column_text}中的值应当在集{values_text}中。",
        "zh-Hant": "錯誤過多，{column_text}之值應該在集合{values_text}中。",
        "ja": "{column_text}の値が{values_text}の集合に含まれているべきテスト単位の失敗の超過。",
        "ko": "{column_text}의 값이 {values_text} 집합에 포함되어야 했던 실패한 테스트 단위 초과.",
        "vi": "Kỳ vọng các giá trị trong {column_text} phải nằm trong tập hợp {values_text}.",
        "ru": "Превышение неудачных тестовых единиц, где значения в {column_text} должны были быть в наборе {values_text}.",
        "cs": "Překročení počtu neúspěšných testů, kde hodnoty ve sloupci {column_text} měly být v množině {values_text}.",
        "pl": "Nie było przekroczenie nieudanych jednostek testowych, gdzie wartości w {column_text} powinny były w zbiorze {values_text}.",
        "da": "Overskridelse af fejlslagne testenheder, hvor værdier i {column_text} skulle have været blandt {values_text}.",
        "sv": "Överskrider misslyckade testenheter där värden i {column_text} borde ha varit bland {values_text}.",
        "nb": "Overskridelse av mislykkede testenheter hvor verdier i {column_text} skulle ha vært i settet av {values_text}.",
        "nl": "Overschrijding van mislukte testeenheden waarbij waarden in {column_text} in de set van {values_text} hadden moeten staan.",
        "fi": "Epäonnistuneiden testiyksikköjen ylitys, joissa sarakkeen {column_text} arvojen olisi pitänyt kuulua joukkoon {values_text}.",
        "is": "Of mörg misheppnuð próf þar sem gildi í {column_text} hefðu átt að vera í mengi {values_text}.",
        "ar": "تجاوز وحدات الاختبار الفاشلة حيث كان يجب أن تكون القيم في {column_text} ضمن مجموعة {values_text}.",
        "hi": "{column_text} में मान {values_text} समूह में होने चाहिए थे, ऐसे असफल परीक्षण इकाइयों की अधिकता।",
        "el": "Υπέρβαση αποτυχημένων μονάδων δοκιμής όπου οι τιμές στη στήλη {column_text} θα έπρεπε να ανήκουν στο σύνολο {values_text}.",
    },
    "not_in_set_expectation_text": {
        "en": "Expect that values in {column_text} should not be in the set of {values_text}.",
        "fr": "On s'attend à ce que les valeurs de {column_text} ne soient pas une des valeurs suivantes : {values_text}.",
        "de": "Erwarten Sie, dass die Werte in {column_text} nicht in der Menge von {values_text} enthalten sein sollten.",
        "it": "Aspettatevi che i valori in {column_text} non debbano essere nel set di {values_text}.",
        "es": "Se espera que los valores en {column_text} no estén en el conjunto de {values_text}.",
        "pt": "Espera-se que os valores em {column_text} não estejam no conjunto de {values_text}.",
        "ro": "Se așteaptă ca valorile din {column_text} să nu fie în setul {values_text}.",
        "tr": "Beklenti, {column_text} 'deki değerlerin {values_text} kümesinde olmaması gerektiğidir.",
        "zh-Hans": "预期在{column_text} 的值应当不在集{values_text}中。",
        "zh-Hant": "{column_text}之值不應在{values_text}集合中。",
        "ja": "{column_text}の値が{values_text}の集合に含まれていないことを期待します。",
        "ko": "{column_text}의 값이 {values_text} 집합에 포함되지 않아야 합니다.",
        "vi": "Kỳ vọng các giá trị trong {column_text} không nằm trong tập hợp {values_text}.",
        "ru": "Ожидайте, что значения в {column_text} не должны быть в наборе {values_text}.",
        "cs": "Očekává se, že hodnoty ve sloupci {column_text} nebudou v množině {values_text}.",
        "pl": "Spodziewaj się, że wartości w {column_text} nie powinny należec do zestawu {values_text}.",
        "da": "Forvent at værdierne i {column_text} ikke er blandt værdierne i {values_text}.",
        "sv": "Förvänta dig att värdena i {column_text} inte ska vara bland värdena i {values_text}.",
        "nb": "Forvent at verdier i {column_text} ikke skal være i settet av {values_text}.",
        "nl": "Verwacht dat de waarden in {column_text} niet in de set van {values_text} mogen voorkomen.",
        "fi": "Odota, että arvot sarakkeessa {column_text} eivät kuulu joukkoon {values_text}.",
        "is": "Væntir þess að gildi í {column_text} séu ekki í mengi {values_text}.",
        "ar": "توقع أن القيم في {column_text} يجب ألا تكون ضمن مجموعة {values_text}.",
        "hi": "अपेक्षा है कि {column_text} में मान {values_text} समूह में नहीं होने चाहिए।",
        "el": "Αναμένεται οι τιμές στη στήλη {column_text} να μην ανήκουν στο σύνολο {values_text}.",
    },
    "not_in_set_failure_text": {
        "en": "Exceedance of failed test units where values in {column_text} should not have been in the set of {values_text}.",
        "fr": "Dépassement des unités de test ayant échoué où les valeurs dans {column_text} n'auraient pas dû être une des valeurs suivantes : {values_text}.",
        "de": "Überschreitung fehlgeschlagener Testeinheiten, bei denen die Werte in {column_text} nicht in der Menge von {values_text} enthalten sein sollten.",
        "it": "Superamento delle unità di test non riuscite in cui i valori in {column_text} non avrebbero dovuto essere nel set di {values_text}.",
        "es": "Se superó el número de unidades de prueba fallidas en que los valores en {column_text} no deberían haber estado en el conjunto de {values_text}.",
        "pt": "Excedeu o número de unidades de teste com falha onde os valores em {column_text} não deveriam estar no conjunto de {values_text}.",
        "ro": "Depășirea unităților de test eșuate unde valorile din {column_text} nu ar fi trebuit să fie în setul {values_text}.",
        "tr": "{column_text} 'deki değerlerin {values_text} kümesinde olmaması gereken başarısız test birimlerinin aşılması.",
        "zh-Hans": "错误过多，其中{column_text}中的值应当不在集{values_text}中。",
        "zh-Hant": "錯誤過多，{column_text}之值不應在{values_text}集合中。",
        "ja": "{column_text}の値が{values_text}の集合に含まれていないべきテスト単位の失敗の超過。",
        "ko": "{column_text}의 값이 {values_text} 집합에 포함되지 않았어야 했던 실패한 테스트 단위 초과.",
        "vi": "Vượt quá số đơn vị kiểm tra thất bại trong đó các giá trị trong {column_text} đáng lẽ không nên nằm trong tập hợp {values_text}.",
        "ru": "Превышение неудачных тестовых единиц, где значения в {column_text} не должны были быть в наборе {values_text}.",
        "cs": "Překročení počtu neúspěšných testů, kde hodnoty ve sloupci {column_text} neměly být v množině {values_text}.",
        "pl": "Nie było przekroczenie nieudanych jednostek testowych, gdzie wartości w {column_text} nie powinny były w zbiorze {values_text}.",
        "da": "Overskridelse af fejlslagne testenheder, hvor værdierne i {column_text} ikke skulle være blandt værdierne i {values_text}.",
        "sv": "Överskrider misslyckade testenheter där värdena i {column_text} inte ska vara bland värdena i {values_text}.",
        "nb": "Overskridelse av mislykkede testenheter hvor verdier i {column_text} ikke skulle ha vært i settet av {values_text}.",
        "nl": "Overschrijding van mislukte testeenheden waarbij waarden in {column_text} niet in de set van {values_text} hadden mogen staan.",
        "fi": "Epäonnistuneiden testiyksikköjen ylitys, joissa sarakkeen {column_text} arvot eivät olisi pitäneet kuulua joukkoon {values_text}.",
        "is": "Of mörg misheppnuð próf þar sem gildi í {column_text} hefðu ekki átt að vera í mengi {values_text}.",
        "ar": "تجاوز وحدات الاختبار الفاشلة حيث كان يجب ألا تكون القيم في {column_text} ضمن مجموعة {values_text}.",
        "hi": "{column_text} में मान {values_text} समूह में नहीं होने चाहिए थे, ऐसे असफल परीक्षण इकाइयों की अधिकता।",
        "el": "Υπέρβαση αποτυχημένων μονάδων δοκιμής όπου οι τιμές στη στήλη {column_text} δε θα έπρεπε να ανήκουν στο σύνολο {values_text}.",
    },
    "between_expectation_text": {
        "en": "Expect that values in {column_text} should be between {value_1} and {value_2}.",
        "fr": "On s'attend à ce que les valeurs de {column_text} soient comprises entre {value_1} et {value_2}.",
        "de": "Erwarten Sie, dass die Werte in {column_text} zwischen {value_1} und {value_2} liegen sollten.",
        "it": "Aspettati che i valori in {column_text} siano compresi tra {value_1} e {value_2}.",
        "es": "Se espera que los valores en {column_text} estén entre {value_1} y {value_2}.",
        "pt": "Espera-se que os valores em {column_text} devem estar entre {value_1} e {value_2}.",
        "ro": "Se așteaptă ca valorile din {column_text} să fie între {value_1} și {value_2}.",
        "tr": "Beklenti, {column_text} 'deki değerlerin {value_1} ile {value_2} arasında olması gerektiğidir.",
        "zh-Hans": "预期在{column_text} 的值应当在 {value_1}和 {value_2}之间。",
        "zh-Hant": "{column_text}之值應該介於{value_1}和{value_2}之間。",
        "ja": "{column_text}の値が{value_1}と{value_2}の間であることを期待します。",
        "ko": "{column_text}의 값이 {value_1}과 {value_2} 사이여야 합니다.",
        "vi": "Kỳ vọng các giá trị trong {column_text} phải nằm trong khoảng từ {value_1} đến {value_2}.",
        "ru": "Ожидайте, что значения в {column_text} должны находиться между {value_1} и {value_2}.",
        "cs": "Očekává se, že hodnoty ve sloupci {column_text} budou mezi {value_1} a {value_2}.",
        "pl": "Spodziewaj się, że wartości w {column_text} powinny zawierac się między {value_1} a {value_2}.",
        "da": "Forvent at værdierne i {column_text} skal være imellem {value_1} og {value_2}.",
        "sv": "Förvänta dig att värdena i {column_text} ligger mellan {value_1} och {value_2}.",
        "nb": "Forvent at verdier i {column_text} skal være mellom {value_1} og {value_2}.",
        "nl": "Verwacht dat de waarden in {column_text} tussen {value_1} en {value_2} moeten liggen.",
        "fi": "Odota, että arvot sarakkeessa {column_text} ovat välillä {value_1} ja {value_2}.",
        "is": "Væntir þess að gildi í {column_text} séu á milli {value_1} og {value_2}.",
        "ar": "توقع أن تكون القيم في {column_text} بين {value_1} و {value_2}.",
        "hi": "अपेक्षा है कि {column_text} में मान {value_1} और {value_2} के बीच होने चाहिए।",
        "el": "Αναμένεται οι τιμές στη στήλη {column_text} να είναι μεταξύ {value_1} και {value_2}.",
    },
    "between_failure_text": {
        "en": "Exceedance of failed test units where values in {column_text} should have been between {value_1} and {value_2}.",
        "fr": "Dépassement des unités de test ayant échoué où les valeurs dans {column_text} auraient dû être comprises entre {value_1} et {value_2}.",
        "de": "Überschreitung fehlgeschlagener Testeinheiten, bei denen die Werte in {column_text} zwischen {value_1} und {value_2} liegen sollten.",
        "it": "Superamento delle unità di test non riuscite in cui i valori in {column_text} avrebbero dovuto essere compresi tra {value_1} e {value_2}.",
        "es": "Se superó el número de unidades de prueba fallidas donde los valores en {column_text} deberían haber estado entre {value_1} y {value_2}.",
        "pt": "Excedeu o número de unidades de teste como falha, onde os valores em {column_text} deveria ter sido entre {value_1} e {value_2}.",
        "ro": "Depășirea unităților de test eșuate unde valorile din {column_text} ar fi trebuit să fie între {value_1} și {value_2}.",
        "tr": "{column_text} 'deki değerlerin {value_1} ile {value_2} arasında olması gereken başarısız test birimlerinin aşılması.",
        "zh-Hans": "错误过多，其中{column_text}中的值应当在 {value_1}和 {value_2}之间。",
        "zh-Hant": "錯誤過多，{column_text}之值應該介於{value_1}和{value_2}之間。",
        "ja": "{column_text}の値が{value_1}と{value_2}の間であるべきテスト単位の失敗の超過。",
        "ko": "{column_text}의 값이 {value_1}과 {value_2} 사이여야 했던 실패한 테스트 단위 초과.",
        "vi": "Vượt quá số đơn vị kiểm tra thất bại trong đó các giá trị trong {column_text} đáng lẽ phải nằm trong khoảng từ {value_1} đến {value_2}.",
        "ru": "Превышение неудачных тестовых единиц, где значения в {column_text} должны были находиться между {value_1} и {value_2}.",
        "cs": "Překročení počtu neúspěšných testů, kde hodnoty ve sloupci {column_text} měly být mezi {value_1} a {value_2}.",
        "pl": "Wystapiło przekroczenie liczby jednostek testowych zakończonych niepowodzeniem, w przypadku których wartości w kolumnie {column_text} powinny znajdowac się między {value_1} a {value_2}.",
        "da": "Overskridelse af fejlslagne testenheder, hvor værdierne i {column_text} skulle have været imellem {value_1} og {value_2}.",
        "sv": "Överskrider misslyckade testenheter där värdena i {column_text} borde ha varit mellan {value_1} och {value_2}.",
        "nb": "Overskridelse av mislykkede testenheter hvor verdier i {column_text} skulle ha vært mellom {value_1} og {value_2}.",
        "nl": "Overschrijding van mislukte testeenheden waarbij waarden in {column_text} tussen {value_1} en {value_2} hadden moeten liggen.",
        "fi": "Epäonnistuneiden testiyksikköjen ylitys, joissa sarakkeen {column_text} arvojen olisi pitänyt olla välillä {value_1} ja {value_2}.",
        "is": "Of mörg misheppnuð próf þar sem gildi í {column_text} hefðu átt að vera á milli {value_1} og {value_2}.",
        "ar": "تجاوز وحدات الاختبار الفاشلة حيث كان يجب أن تكون القيم في {column_text} بين {value_1} و {value_2}.",
        "hi": "{column_text} में मान {value_1} और {value_2} के बीच होने चाहिए थे, ऐसे असफल परीक्षण इकाइयों की अधिकता।",
        "el": "Υπέρβαση αποτυχημένων μονάδων δοκιμής όπου οι τιμές στη στήλη {column_text} θα έπρεπε να είναι μεταξύ {value_1} και {value_2}.",
    },
    "not_between_expectation_text": {
        "en": "Expect that values in {column_text} should not be between {value_1} and {value_2}.",
        "fr": "On s'attend à ce que les valeurs de {column_text} ne soient pas comprises entre {value_1} et {value_2}.",
        "de": "Erwarten Sie, dass die Werte in {column_text} nicht zwischen {value_1} und {value_2} liegen sollten.",
        "it": "Aspettatevi che i valori in {column_text} non debbano essere compresi tra {value_1} e {value_2}.",
        "es": "Se espera que los valores en {column_text} no estén entre {value_1} y {value_2}.",
        "pt": "Espera-se que os valores em {column_text} não deveria estar entre {value_1} e {value_2}.",
        "ro": "Se așteaptă ca valorile din {column_text} să nu fie între {value_1} și {value_2}.",
        "tr": "Beklenti, {column_text} 'deki değerlerin {value_1} ile {value_2} arasında olmaması gerektiğidir.",
        "zh-Hans": "预期在{column_text} 的值应当不在 {value_1}和 {value_2}之间。",
        "zh-Hant": "{column_text}之值不應該介於{value_1}和{value_2}之間。",
        "ja": "{column_text}の値が{value_1}と{value_2}の間でないことを期待します。",
        "ko": "{column_text}의 값이 {value_1}과 {value_2} 사이가 아니어야 합니다.",
        "vi": "Kỳ vọng các giá trị trong {column_text} không nằm trong khoảng từ {value_1} đến {value_2}.",
        "ru": "Ожидайте, что значения в {column_text} не должны находиться между {value_1} и {value_2}.",
        "cs": "Očekává se, že hodnoty ve sloupci {column_text} nebudou mezi {value_1} a {value_2}.",
        "pl": "Spodziewaj się, że wartości w {column_text} nie powinny byc między {value_1} a {value_2}.",
        "da": "Forvent at værdier i {column_text} er imellem {value_1} og {value_2}.",
        "sv": "Förvänta dig att värdena i {column_text} ligger mellan {value_1} och {value_2}.",
        "nb": "Forvent at verdier i {column_text} ikke skal være mellom {value_1} og {value_2}.",
        "nl": "Verwacht dat de waarden in {column_text} niet tussen {value_1} en {value_2} mogen liggen.",
        "fi": "Odota, että arvot sarakkeessa {column_text} eivät ole välillä {value_1} ja {value_2}.",
        "is": "Væntir þess að gildi í {column_text} séu ekki á milli {value_1} og {value_2}.",
        "ar": "توقع أن القيم في {column_text} يجب ألا تكون بين {value_1} و {value_2}.",
        "hi": "अपेक्षा है कि {column_text} में मान {value_1} और {value_2} के बीच नहीं होने चाहिए।",
        "el": "Αναμένεται οι τιμές στη στήλη {column_text} να μην είναι μεταξύ {value_1} και {value_2}.",
    },
    "not_between_failure_text": {
        "en": "Exceedance of failed test units where values in {column_text} should not have been between {value_1} and {value_2}.",
        "fr": "Dépassement des unités de test ayant échoué où les valeurs dans {column_text} n'auraient pas dû être comprises entre {value_1} et {value_2}.",
        "de": "Überschreitung fehlgeschlagener Testeinheiten, bei denen die Werte in {column_text} nicht zwischen {value_1} und {value_2} liegen sollten.",
        "it": "Superamento delle unità di test non riuscite in cui i valori in {column_text} non avrebbero dovuto essere compresi tra {value_1} e {value_2}.",
        "es": "Se superó el número de unidades de prueba fallidas en que los valores en {column_text} no deberían haber estado entre {value_1} y {value_2}.",
        "pt": "Excedeu o número de unidades de teste com falha onde os valores em {column_text} não deveria estar entre {value_1} e {value_2}.",
        "ro": "Depășirea unităților de test eșuate unde valorile din {column_text} nu ar fi trebuit să fie între {value_1} și {value_2}.",
        "tr": "{column_text} 'deki değerlerin {value_1} ile {value_2} arasında olmaması gereken başarısız test birimlerinin aşılması.",
        "zh-Hans": "错误过多，其中{column_text}中的值应当不在 {value_1}和 {value_2}之间。",
        "zh-Hant": "錯誤過多，{column_text}之值不應該介於{value_1}和{value_2}之間。",
        "ja": "{column_text}の値が{value_1}と{value_2}の間でないべきテスト単位の失敗の超過。",
        "ko": "{column_text}의 값이 {value_1}과 {value_2} 사이가 아니어야 했던 실패한 테스트 단위 초과.",
        "vi": "Vượt quá số đơn vị kiểm tra thất bại trong đó các giá trị trong {column_text} đáng lẽ không nên nằm trong khoảng từ {value_1} đến {value_2}.",
        "ru": "Превышение неудачных тестовых единиц, где значения в {column_text} не должны были находиться между {value_1} и {value_2}.",
        "cs": "Překročení počtu neúspěšných testů, kde hodnoty ve sloupci {column_text} neměly být mezi {value_1} a {value_2}.",
        "pl": "Wystapiło przekroczenie liczby jednostek testowych zakończonych niepowodzeniem, w przypadku których wartości w kolumnie {column_text} nie powinny znajdowac się między {value_1} a {value_2}.",
        "da": "Overskridelse af testenheder, hvor værdierne i {column_text} ikke skulle have været imellem {value_1} og {value_2}.",
        "sv": "Överskrider testenheter där värdena i {column_text} inte borde ha varit mellan {value_1} och {value_2}.",
        "nb": "Overskridelse av mislykkede testenheter hvor verdier i {column_text} ikke skulle ha vært mellom {value_1} og {value_2}.",
        "nl": "Overschrijding van mislukte testeenheden waarbij waarden in {column_text} niet tussen {value_1} en {value_2} mogen liggen.",
        "fi": "Epäonnistuneiden testiyksikköjen ylitys, joissa sarakkeen {column_text} arvot eivät olisi pitäneet olla välillä {value_1} ja {value_2}.",
        "is": "Of mörg misheppnuð próf þar sem gildi í {column_text} hefðu ekki átt að vera á milli {value_1} og {value_2}.",
        "ar": "تجاوز وحدات الاختبار الفاشلة حيث كان يجب ألا تكون القيم في {column_text} بين {value_1} و {value_2}.",
        "hi": "{column_text} में मान {value_1} और {value_2} के बीच नहीं होने चाहिए थे, ऐसे असफल परीक्षण इकाइयों की अधिकता।",
        "el": "Υπέρβαση αποτυχημένων μονάδων δοκιμής όπου οι τιμές στη στήλη {column_text} δε θα έπρεπε να είναι μεταξύ {value_1} και {value_2}.",
    },
    "null_expectation_text": {
        "en": "Expect that all values in {column_text} should be Null.",
        "fr": "On s'attend à ce que toutes les valeurs de {column_text} soient Null.",
        "de": "Erwarten Sie, dass alle Werte in {column_text} Null sein sollten.",
        "it": "Aspettatevi che tutti i valori in {column_text} siano Null.",
        "es": "Se espera que todos los valores en {column_text} sean Null.",
        "pt": "Espera-se que todos os valores em {column_text} sejam Null.",
        "ro": "Se așteaptă ca toate valorile din {column_text} să fie Null.",
        "tr": "Beklenti, {column_text} 'deki tüm değerlerin Null olması gerektiğidir.",
        "zh-Hans": "预期在{column_text} 的值应当为Null。",
        "zh-Hant": "{column_text}之值應為Null。",
        "ja": "{column_text}のすべての値がNullであることを期待します。",
        "ko": "{column_text}의 모든 값이 Null이어야 합니다.",
        "vi": "Kỳ vọng tất cả các giá trị trong {column_text} đều là Null.",
        "ru": "Ожидайте, что все значения в {column_text} должны быть Null.",
        "cs": "Očekává se, že všechny hodnoty ve sloupci {column_text} budou Null.",
        "pl": "Spodziewaj się, że wszystkie wartości w {column_text} powinny miec wartośc Null.",
        "da": "Forvent at all værdier i {column_text} er Null.",
        "sv": "Förvänta dig att alla värden i {column_text} är Null.",
        "nb": "Forvent at alle verdier i {column_text} skal være Null.",
        "nl": "Verwacht dat alle waarden in {column_text} Null moeten zijn.",
        "fi": "Odota, että kaikki arvot sarakkeessa {column_text} ovat Null.",
        "is": "Væntir þess að öll gildi í {column_text} séu Null.",
        "ar": "توقع أن جميع القيم في {column_text} يجب أن تكون خالية.",
        "hi": "अपेक्षा है कि {column_text} में सभी मान Null होने चाहिए।",
        "el": "Αναμένεται όλες οι τιμές στη στήλη {column_text} να είναι Null.",
    },
    "null_failure_text": {
        "en": "Exceedance of failed test units where values in {column_text} should have been Null.",
        "fr": "Dépassement des unités de test ayant échoué où les valeurs dans {column_text} auraient dû être Null.",
        "de": "Überschreitung fehlgeschlagener Testeinheiten, bei denen die Werte in {column_text} Null sein sollten.",
        "it": "Superamento delle unità di test non riuscite in cui i valori in {column_text} avrebbero dovuto essere Null.",
        "es": "Se superó el número de unidades de prueba fallidas en que los valores en {column_text} son Null.",
        "pt": "Excedeu o número de unidades de teste com falha onde os valores em {column_text} são Null.",
        "ro": "Depășirea unităților de test eșuate unde valorile din {column_text} ar fi trebuit să fie Null.",
        "tr": "{column_text} içindeki değerlerin Null olması gereken başarısız test birimlerinin aşılması.",
        "zh-Hans": "错误过多，其中{column_text}中的值应当为Null。",
        "zh-Hant": "錯誤過多，{column_text}之值應為Null。",
        "ja": "{column_text}の値がNullであるべきテスト単位の失敗の超過。",
        "ko": "{column_text}의 값이 Null이어야 했던 실패한 테스트 단위 초과.",
        "vi": "Vượt quá số đơn vị kiểm tra thất bại trong đó các giá trị trong {column_text} đáng lẽ phải là Null.",
        "ru": "Превышение неудачных тестовых единиц, где значения в {column_text} должны были быть Null.",
        "cs": "Překročení počtu neúspěšných testů, kde hodnoty ve sloupci {column_text} měly být Null.",
        "pl": "Nie było przekroczenie nieudanych jednostek testowych, gdzie wartości w {column_text} powinny były Null.",
        "da": "Overskridelse af testenheder, hvor værdierne i {column_text} skulle have været Null.",
        "sv": "Överskrider testenheter där värdena i {column_text} borde ha varit Null.",
        "nb": "Overskridelse av mislykkede testenheter hvor verdier i {column_text} skulle ha vært Null.",
        "nl": "Overschrijding van mislukte testeenheden waarbij waarden in {column_text} Null hadden moeten zijn.",
        "fi": "Epäonnistuneiden testiyksikköjen ylitys, joissa sarakkeen {column_text} arvojen olisi pitänyt olla Null.",
        "is": "Of mörg misheppnuð próf þar sem gildi í {column_text} hefðu átt að vera Null.",
        "ar": "تجاوز وحدات الاختبار الفاشلة حيث كان يجب أن تكون القيم في {column_text} خالية.",
        "hi": "{column_text} में सभी मान Null होने चाहिए थे, ऐसे असफल परीक्षण इकाइयों की अधिकता।",
        "el": "Υπέρβαση αποτυχημένων μονάδων δοκιμής όπου οι τιμές στη στήλη {column_text} θα έπρεπε να είναι Null.",
    },
    "not_null_expectation_text": {
        "en": "Expect that all values in {column_text} should not be Null.",
        "fr": "On s'attend à ce que toutes les valeurs de {column_text} ne soient pas Null.",
        "de": "Erwarten Sie, dass alle Werte in {column_text} nicht Null sein sollten.",
        "it": "Aspettatevi che tutti i valori in {column_text} non debbano essere Null.",
        "es": "Se espera que todos los valores en {column_text} no sean Null.",
        "pt": "Espera-se que todos os valores em {column_text} não sejam Null.",
        "ro": "Se așteaptă ca nicio valoare din {column_text} să nu fie Null.",
        "tr": "Beklenti, {column_text} 'deki tüm değerlerin Null olmaması gerektiğidir.",
        "zh-Hans": "预期在{column_text} 的值应当不为Null。",
        "zh-Hant": "{column_text}之值不應為Null。",
        "ja": "{column_text}のすべての値がNullでないことを期待します。",
        "ko": "{column_text}의 모든 값이 Null이 아니어야 합니다.",
        "vi": "Kỳ vọng tất cả các giá trị trong {column_text} không phải là Null.",
        "ru": "Ожидайте, что все значения в {column_text} не должны быть Null.",
        "cs": "Očekává se, že žádné hodnoty ve sloupci {column_text} nebudou Null.",
        "pl": "Spodziewaj się, że wszystkie wartości w {column_text} nie powinny miec wartości Null.",
        "da": "Forvent at ingen af værdierne i {column_text} er Null.",
        "sv": "Förvänta dig att inget av värdena i {column_text} ska vara Null.",
        "nb": "Forvent at ingen verdier i {column_text} skal være Null.",
        "nl": "Verwacht dat alle waarden in {column_text} niet Null mogen zijn.",
        "fi": "Odota, että kaikki arvot sarakkeessa {column_text} eivät ole Null.",
        "is": "Væntir þess að engin gildi í {column_text} séu Null.",
        "ar": "توقع أن جميع القيم في {column_text} يجب ألا تكون خالية.",
        "hi": "अपेक्षा है कि {column_text} में सभी मान Null नहीं होने चाहिए।",
        "el": "Αναμένεται όλες οι τιμές στη στήλη {column_text} να μην είναι Null.",
    },
    "not_null_failure_text": {
        "en": "Exceedance of failed test units where values in {column_text} should not have been Null.",
        "fr": "Dépassement des unités de test ayant échoué où les valeurs dans {column_text} n'auraient pas dû être Null.",
        "de": "Überschreitung fehlgeschlagener Testeinheiten, bei denen die Werte in {column_text} nicht Null sein sollten.",
        "it": "Superamento delle unità di test non riuscite in cui i valori in {column_text} non avrebbero dovuto essere Null.",
        "es": "Se superó el número de unidades de prueba fallidas en que los valores en {column_text} no son Null.",
        "pt": "Excedeu o número de unidades de teste com falhas onde os valores em {column_text} não são Null.",
        "ro": "Depășirea unităților de test eșuate unde valorile din {column_text} nu ar fi trebuit să fie Null.",
        "tr": "{column_text} içindeki değerlerin Null olmaması gereken başarısız test birimlerinin aşılması.",
        "zh-Hans": "错误过多，其中{column_text}中的值应当不为Null。",
        "zh-Hant": "錯誤過多，{column_text}之值不應為Null。",
        "ja": "{column_text}の値がNullでないべきテスト単位の失敗の超過。",
        "ko": "{column_text}의 값이 Null이 아니어야 했던 실패한 테스트 단위 초과.",
        "vi": "Vượt quá số đơn vị kiểm tra thất bại trong đó các giá trị trong {column_text} đáng lẽ không nên là Null.",
        "ru": "Превышение неудачных тестовых единиц, где значения в {column_text} не должны были быть Null.",
        "cs": "Překročení počtu neúspěšných testů, kde hodnoty ve sloupci {column_text} neměly být Null.",
        "pl": "Nie było przekroczenie nieudanych jednostek testowych, gdzie wartości w {column_text} nie powinny były zostac Null.",
        "da": "Overskridelse af antallet af fejlslagne testenheder, hvor ingen af værdierne i {column_text} skulle have været Null.",
        "sv": "Överskrider antalet misslyckade testenheter där inget av värdena i {column_text} borde ha varit Null.",
        "nb": "Overskridelse av mislykkede testenheter hvor verdier i {column_text} ikke skulle ha vært Null.",
        "nl": "Overschrijding van mislukte testeenheden waarbij waarden in {column_text} niet Null hadden mogen zijn.",
        "fi": "Epäonnistuneiden testiyksikköjen ylitys, joissa sarakkeen {column_text} arvot eivät olisi pitäneet olla Null.",
        "is": "Of mörg misheppnuð próf þar sem gildi í {column_text} hefðu ekki átt að vera Null.",
        "ar": "تجاوز وحدات الاختبار الفاشلة حيث كان يجب ألا تكون القيم في {column_text} خالية.",
        "hi": "{column_text} में कोई भी मान Null नहीं होना चाहिए था, ऐसे असफल परीक्षण इकाइयों की अधिकता।",
        "el": "Υπέρβαση αποτυχημένων μονάδων δοκιμής όπου οι τιμές στη στήλη {column_text} δε θα έπρεπε να είναι Null.",
    },
    "regex_expectation_text": {
        "en": "Expect that values in {column_text} should match the regular expression: {values_text}.",
        "fr": "On s'attend à ce que les valeurs de {column_text} correspondent à l'expression régulière : {values_text}.",
        "de": "Erwarten Sie, dass die Werte in {column_text} mit dem regulären Ausdruck {values_text} übereinstimmen.",
        "it": "Aspettati che i valori in {column_text} debbano corrispondere all'espressione regolare: {values_text}.",
        "es": "Se espera que los valores en {column_text} coincidan con la expresión regular: {values_text}.",
        "pt": "Espera-se que os valores em {column_text} concorde com a expressão regular: {values_text}.",
        "ro": "Se așteaptă ca valorile din {column_text} să corespundă expresiei regulate: {values_text}.",
        "tr": "Beklenti, {column_text} 'deki değerlerin şu normal ifadeyle eşleşmesi gerektiğidir: {values_text}.",
        "zh-Hans": "预期在{column_text} 的值应当匹配正则表达式。",
        "zh-Hant": "{column_text}之值應該匹配正則表達式。",
        "ja": "{column_text}の値が正規表現: {values_text}に一致することを期待します。",
        "ko": "{column_text}의 값이 정규식 {values_text}와 일치해야 합니다.",
        "vi": "Kỳ vọng các giá trị trong {column_text} phải khớp với biểu thức chính quy: {values_text}.",
        "ru": "Ожидайте, что значения в {column_text} должны соответствовать регулярному выражению: {values_text}.",
        "cs": "Očekává se, že hodnoty ve sloupci {column_text} budou odpovídat regulárnímu výrazu: {values_text}.",
        "pl": "Spodziewaj się, że wartości w {column_text} powinny byc zgodne z wyrażeniem regularnym: {values_text}.",
        "da": "Forvent at værdierne i {column_text} stemmer overens med følgende regular expression: {values_text}.",
        "sv": "Förvänta dig att värdena i {column_text} ska matcha följande reguljära uttryck: {values_text}.",
        "nb": "Forvent at verdier i {column_text} skal samsvare med regulæruttrykket: {values_text}.",
        "nl": "Verwacht dat de waarden in {column_text} overeenkomen met de reguliere expressie {values_text}.",
        "fi": "Odota, että arvot sarakkeessa {column_text} vastaavat säännöllistä lauseketta: {values_text}.",
        "is": "Væntir þess að gildi í {column_text} passi við reglulega segðina: {values_text}.",
        "ar": "توقع أن تتطابق القيم في {column_text} مع التعبير المنتظم: {values_text}.",
        "hi": "अपेक्षा है कि {column_text} में मान नियमित अभिव्यक्ति से मेल खाने चाहिए: {values_text}।",
        "el": "Αναμένεται οι τιμές στη στήλη {column_text} να ταιριάζουν με την κανονική έκφραση: {values_text}.",
    },
    "regex_failure_text": {
        "en": "Exceedance of failed test units where values in {column_text} should have matched the regular expression: {values_text}.",
        "fr": "Dépassement des unités de test ayant échoué où les valeurs dans {column_text} auraient dû correspondre à l'expression régulière : {values_text}.",
        "de": "Überschreitung fehlgeschlagener Testeinheiten, bei denen die Werte in {column_text} mit dem regulären Ausdruck {values_text} übereinstimmen sollten.",
        "it": "Superamento delle unità di test non riuscite in cui i valori in {column_text} avrebbero dovuto corrispondere all'espressione regolare: {values_text}.",
        "es": "Se superó el número de unidades de prueba fallidas en que los valores en {column_text} deberían coincidir con la expresión regular: {values_text}.",
        "pt": "Excedeu o número de unidades de teste com falha onde os valores em {column_text} deve concordar com a expressão regular: {values_text}.",
        "ro": "Depășirea unităților de test eșuate unde valorile din {column_text} ar fi trebuit să corespundă expresiei regulate: {values_text}.",
        "tr": "{column_text} daki değerlerin normal ifade {values_text} ile eşleşmesi gereken başarısız test birimlerinin aşılması.",
        "zh-Hans": "错误过多，其中{column_text}中的值应当匹配正则表达式。",
        "zh-Hant": "錯誤過多，{column_text}之值應該匹配正則表達式。",
        "ja": "{column_text}の値が正規表現: {values_text}に一致するべきテスト単位の失敗の超過。",
        "ko": "{column_text}의 값이 정규식 {values_text}와 일치했어야 했던 실패한 테스트 단위 초과.",
        "vi": "Vượt quá số đơn vị kiểm tra thất bại trong đó các giá trị trong {column_text} đáng lẽ phải khớp với biểu thức chính quy: {values_text}.",
        "ru": "Превышение неудачных тестовых единиц, где значения в {column_text} должны были соответствовать регулярному выражению: {values_text}.",
        "cs": "Překročení počtu neúspěšných testů, kde hodnoty ve sloupci {column_text} měly odpovídat regulárnímu výrazu: {values_text}.",
        "pl": "Wystapiło przekroczenie liczby jednostek testowych zakończonych niepowodzeniem, w przypadku których wartości w {column_text} powinny odpowiadac wyrażeniu regularnemu: {values_text}.",
        "da": "Overskridelse af antallet af fejlslagne testenheder, hvor værdier {column_text} skulle have været i overensstemmelse med følgende regular expression: {values_text}.",
        "sv": "Överskrider antalet misslyckade testenheter där värden {column_text} borde ha matchat följande reguljära uttryck: {values_text}.",
        "nb": "Overskridelse av mislykkede testenheter hvor verdier i {column_text} skulle ha samsvart med regulæruttrykket: {values_text}.",
        "nl": "Overschrijding van mislukte testeenheden waarbij waarden in {column_text} overeen moeten komen met de reguliere expressie: {values_text}.",
        "fi": "Epäonnistuneiden testiyksikköjen ylitys, joissa sarakkeen {column_text} arvojen olisi pitänyt vastata säännöllistä lauseketta: {values_text}.",
        "is": "Of mörg misheppnuð próf þar sem gildi í {column_text} hefðu átt að passa við reglulega segðina: {values_text}.",
        "ar": "تجاوز وحدات الاختبار الفاشلة حيث كان يجب أن تتطابق القيم في {column_text} مع التعبير المنتظم: {values_text}.",
        "hi": "{column_text} में मान नियमित अभिव्यक्ति से मेल खाने चाहिए थे: {values_text}, ऐसे असफल परीक्षण इकाइयों की अधिकता।",
        "el": "Υπέρβαση αποτυχημένων μονάδων δοκιμής όπου οι τιμές στη στήλη {column_text} θα έπρεπε να ταιριάζουν με την κανονική έκφραση: {values_text}.",
    },
    "col_vals_expr_expectation_text": {
        "en": "Expect that values should agree with the given Python expression.",
        "fr": "On s'attend à ce que les valeurs soient en accord avec l'expression Python donnée.",
        "de": "Erwarten Sie, dass die Werte mit dem angegebenen Python-Ausdruck übereinstimmen.",
        "it": "Aspettatevi che i valori siano in accordo con l'espressione Python fornita.",
        "es": "Se espera que los valores sean los mismos que en la expresión Python dada.",
        "pt": "Espera-se que os valores sejam os mesmos como na expressão de Python dada.",
        "ro": "Se așteaptă ca valorile să corespundă expresiei Python furnizate.",
        "tr": "Beklenti, değerlerin verilen Python ifadesine uyması gerektiğidir.",
        "zh-Hans": "值应当与给定的Python表达式一致。",
        "zh-Hant": "值應該與給定的Python表達式一致。",
        "ja": "値が指定されたPython式に一致することを期待します。",
        "ko": "값이 주어진 Python 표현식과 일치해야 합니다.",
        "vi": "Kỳ vọng các giá trị phải phù hợp với biểu thức Python đã cho.",
        "ru": "Ожидайте, что значения должны совпадать с заданным выражением Python.",
        "cs": "Očekává se, že hodnoty budou vyhovovat danému výrazu v Pythonu.",
        "pl": "Oczekuj, że wartości powinny byc zgodne z podanym wyrażeniem Python.",
        "da": "Forvent at værdier er i overensstemmelse med den pågældende Python udtryk.",
        "sv": "Förvänta dig att värden överensstämmer med det Python-uttrycket.",
        "nb": "Forvent at verdier skal samsvare med det gitte Python-uttrykket.",
        "nl": "Verwacht dat de waarden overeenkomen met de gegeven Python-uitdrukking.",
        "fi": "Odota, että arvot vastaavat annettua Python-lauseketta.",
        "is": "Væntir þess að gildi samræmist gefnu Python-segðinni.",
        "ar": "توقع أن تتوافق القيم مع تعبير بايثون المعطى.",
        "hi": "अपेक्षा है कि मान दिए गए Python अभिव्यक्ति से मेल खाने चाहिए।",
        "el": "Αναμένεται οι τιμές να συμφωνούν με τη δοθείσα έκφραση Python.",
    },
    "col_vals_expr_failure_text": {
        "en": "Exceedance of failed test units where values should have agreed with the given Python expression.",
        "fr": "Dépassement des unités de test ayant échoué les valeurs auraient dû correspondre à l'expression Python donnée.",
        "de": "Überschreitung fehlgeschlagener Testeinheiten, bei denen die Werte mit dem angegebenen Python-Ausdruck übereinstimmen sollten.",
        "it": "Superamento di unità di test fallite in cui i valori avrebbero dovuto concordare con l'espressione Python fornita.",
        "es": "Se superó el número de unidades de prueba fallidas en que los valores deberían haber sido los mismos que en la expresión Python dada.",
        "pt": "Excedeu o número de unidades de teste com falha onde os valores devem ter sido o mesmo como na expressão de Python dada.",
        "ro": "Depășirea unităților de test eșuate unde valorile ar fi trebuit să corespundă expresiei Python furnizate.",
        "tr": "Değerlerin belirtilen Python ifadesiyle eşleşmesi gereken başarısız test birimlerinin aşılması.",
        "zh-Hans": "错误过多，其中值应当与给定的Python表达式一致。",
        "zh-Hant": "錯誤過多，值應該與給定的Python表達式一致。",
        "ja": "値が指定されたPython式に一致するべきテスト単位の失敗の超過。",
        "ko": "값이 주어진 Python 표현식과 일치했어야 했던 실패한 테스트 단위 초과.",
        "vi": "Vượt quá số đơn vị kiểm tra thất bại trong đó các giá trị đáng lẽ phải phù hợp với biểu thức Python đã cho.",
        "ru": "Превышение неудачных тестовых единиц, где значения должны были быть согласованы с заданным выражением Python.",
        "cs": "Překročení počtu neúspěšných testů, kde hodnoty měly vyhovovat danému výrazu v Pythonu.",
        "pl": "Wystapiło przekroczenie niepomyślnych jednostek testowych, w przypadku których wartości powinny zgadzac się z podanym wyrażeniem Python.",
        "da": "Overskridelse af antallet af fejlslagne testenheder, hvor værdier skulle have været i overensstemmelse med det pågældende Python udtryk.",
        "sv": "Överstiger antalet misslyckade testenheter där värden borde ha varit i enlighet med relevant Python-uttryck.",
        "nb": "Overskridelse av mislykkede testenheter hvor verdier skulle ha samsvart med det gitte Python-uttrykket.",
        "nl": "Overschrijding van mislukte testeenheden waarbij waarden overeen hadden moeten komen met de gegeven Python-uitdrukking.",
        "fi": "Epäonnistuneiden testiyksikköjen ylitys, joissa arvojen olisi pitänyt vastata annettua Python-lauseketta.",
        "is": "Of mörg misheppnuð próf þar sem gildi hefðu átt að samræmast gefnu Python-segðinni.",
        "ar": "تجاوز وحدات الاختبار الفاشلة حيث كان يجب أن تتوافق القيم مع تعبير بايثون المعطى.",
        "hi": "मान दिए गए Python अभिव्यक्ति से मेल खाने चाहिए थे, ऐसे असफल परीक्षण इकाइयों की अधिकता।",
        "el": "Υπέρβαση αποτυχημένων μονάδων δοκιμής όπου οι τιμές θα έπρεπε να συμφωνούν με τη δοθείσα έκφραση Python.",
    },
    "col_exists_expectation_text": {
        "en": "Expect that column {column_text} exists.",
        "fr": "On s'attend à ce que la colonne {column_text} existe.",
        "de": "Erwarten Sie, dass die Spalte {column_text} vorhanden ist.",
        "it": "Aspettati che la colonna {column_text} esista.",
        "es": "Se espera que exista la columna {column_text}.",
        "pt": "Espera-se que exista a coluna {column_text}.",
        "ro": "Se așteaptă ca coloana {column_text} să existe.",
        "tr": "Beklenti, {column_text} sütununun var olmasıdır.",
        "zh-Hans": "预期列 {column_text}存在。",
        "zh-Hant": "{column_text}列應該存在。",
        "ja": "列{column_text}が存在することを期待します。",
        "ko": "열 {column_text}이 존재해야 합니다.",
        "vi": "Kỳ vọng cột {column_text} tồn tại.",
        "ru": "Ожидайте, что столбец {column_text} существует.",
        "cs": "Očekává se, že sloupec {column_text} existuje.",
        "pl": "Spodziewaj się, że kolumna {column_text} istnieje.",
        "da": "Forvent at kolonnen {column_text} findes.",
        "sv": "Förvänta dig att kolumnen {column_text} ska finnas.",
        "nb": "Forvent at kolonnen {column_text} eksisterer.",
        "nl": "Verwacht dat de kolom {column_text} bestaat.",
        "fi": "Odota, että sarake {column_text} on olemassa.",
        "is": "Væntir þess að dálkurinn {column_text} sé til.",
        "ar": "توقع وجود العمود {column_text}.",
        "hi": "अपेक्षा है कि स्तंभ {column_text} मौजूद होना चाहिए।",
        "el": "Αναμένεται η στήλη {column_text} να υπάρχει.",
    },
    "col_exists_failure_text": {
        "en": "Failure to validate that column {column_text} exists.",
        "fr": "Échec de validation de l'existence de la colonne {column_text}.",
        "de": "Fehler beim Überprüfen, ob die Spalte {column_text} vorhanden ist.",
        "it": "Impossibile convalidare l'esistenza della colonna {column_text}.",
        "es": "Error al validar que la columna {column_text} exista.",
        "pt": "Erro ao validar que a coluna {column_text} existe.",
        "ro": "Eșec la validarea existenței coloanei {column_text}.",
        "tr": "{column_text} sütununun var olduğu doğrulanamadı.",
        "zh-Hans": "未成功确认列{column_text}存在。",
        "zh-Hant": "未成功確認{column_text}列存在。",
        "ja": "列{column_text}が存在することを検証できませんでした。",
        "ko": "열 {column_text}이 존재하는지 검증 실패.",
        "vi": "Thất bại khi xác nhận rằng cột {column_text} tồn tại.",
        "ru": "Неверка этого столбца {column_text} существует.",
        "cs": "Nepovedlo se ověřit, že sloupec {column_text} existuje.",
        "pl": "Niepowodzenie weryfikacji, że kolumna {column_text} istnieje.",
        "da": "Fejl da det ikke kunne verificeres at {column_text} findes.",
        "sv": "Fel eftersom {column_text} inte kunde verifieras.",
        "nb": "Kunne ikke validere at kolonnen {column_text} eksisterer.",
        "nl": "Het is mislukt om de kolom {column_text} te valideren.",
        "fi": "Sarakkeen {column_text} olemassaolon vahvistaminen epäonnistui.",
        "is": "Mistókst að staðfesta að dálkurinn {column_text} sé til.",
        "ar": "فشل في التحقق من وجود العمود {column_text}.",
        "hi": "स्तंभ {column_text} के अस्तित्व को सत्यापित करने में विफलता।",
        "el": "Αποτυχία επιβεβαίωσης ότι η στήλη {column_text} υπάρχει.",
    },
    "all_row_distinct_expectation_text": {
        "en": "Expect entirely distinct rows across all columns.",
        "fr": "On s'attend à des lignes entièrement distinctes dans toutes les colonnes.",
        "de": "Erwarten Sie in allen Spalten einzigartige Zeilen.",
        "it": "Aspettati righe completamente distinte su tutte le colonne.",
        "es": "Se esperan filas completamente distintas en todas las columnas.",
        "pt": "Espera-sa linhas completamente diferentes em todas as colunas.",
        "ro": "Se așteaptă rânduri complet distincte în toate coloanele.",
        "tr": "Tüm sütunlarda tamamen farklı satırlar bekleyin.",
        "zh-Hans": "预期在所有的列，行都应当完全不同（即无重复）。",
        "zh-Hant": "在所有列裡，不應出現重複的行。",
        "ja": "全ての列において完全に異なる行を期待します。",
        "ko": "모든 열에 걸쳐 완전히 고유한 행이 있어야 합니다.",
        "vi": "Kỳ vọng các hàng hoàn toàn khác biệt trên tất cả các cột.",
        "ru": "Ожидайте совершенно разные строки во всех столбцах.",
        "cs": "Očekávají se úplně odlišné řádky napříč všemi sloupci.",
        "pl": "Oczekuj unikalnych wierszy we wszystkich kolumnach.",
        "da": "Forvent unikke værdier i alle rækker i alle kolonner.",
        "sv": "Förvänta dig unika värden i alla rader i alla kolumner.",
        "nb": "Forvent at rader er helt unike på tvers av alle kolonner.",
        "nl": "Verwacht unieke rijen in alle kolommen.",
        "fi": "Odota täysin erillisiä rivejä kaikissa sarakkeissa.",
        "is": "Væntir þess að allar raðir séu aðskildar yfir alla dálka.",
        "ar": "توقع صفوف متميزة تمامًا عبر جميع الأعمدة.",
        "hi": "अपेक्षा है कि सभी स्तंभों में पंक्तियां पूरी तरह से अलग होनी चाहिए।",
        "el": "Αναμένεται πλήρως διακριτές γραμμές σε όλες τις στήλες.",
    },
    "all_row_distinct_failure_text": {
        "en": "Exceedance of failed test units where there weren't distinct rows across all columns.",
        "fr": "Dépassement des unités de test ayant échoué là où il n'y avait pas des lignes distinctes dans toutes les colonnes.",
        "de": "Überschreitung fehlgeschlagener Testeinheiten, bei denen nicht in allen Spalten einzigartige Zeilen vorhanden waren.",
        "it": "Superamento di unità di test fallite in cui non c'erano righe distinte su tutte le colonne.",
        "es": "Se superó el número de unidades de prueba fallidas en que no hay filas distintas en todas las columnas.",
        "pt": "Excedeu o número de unidades de teste com falha onde não ha linhas diferentes nas colunas selecionadas.",
        "ro": "Depășirea unităților de test eșuate unde nu au existat rânduri distincte în toate coloanele.",
        "tr": "Tüm sütunlarda benzersiz satırların olmadığı başarısız test birimlerinin aşılması.",
        "zh-Hans": "错误过多，其中在所有的列，行存在相同之处（即有重复）。",
        "zh-Hant": "錯誤過多，在所有列裡，有重複的行出現。",
        "ja": "全ての列において完全に異なる行でないテスト単位の失敗の超過。",
        "ko": "모든 열에 걸쳐 고유한 행이 아니었던 실패한 테스트 단위 초과.",
        "vi": "Vượt quá số đơn vị kiểm tra thất bại trong đó các hàng không hoàn toàn khác biệt trên tất cả các cột.",
        "ru": "Превышение неудачных испытательных блоков, где не было различных строк по всем столбцам.",
        "cs": "Překročení počtu neúspěšných testů, kde nebyly odlišné řádky napříč všemi sloupci.",
        "pl": "Wystapiło przekroczenie liczby niepomyślnych jednostek testowych, gdy nie było odrębnych wierszy we wszystkich kolumnach.",
        "da": "Overskridelse af antal fejlslagne enhedstests, hvor der ikke var unikke værdier i alle rækker i alle kolonner.",
        "sv": "Överstiger antalet misslyckade enhetstest där det inte fanns några unika värden i alla rader i alla kolumner.",
        "nb": "Overskridelse av mislykkede testenheter hvor det ikke var unike rader på tvers av alle kolonner.",
        "nl": "Overschrijding van mislukte testeenheden waarbij er niet in alle kolommen verschillende rijen waren.",
        "fi": "Epäonnistuneiden testiyksikköjen ylitys, joissa ei ollut erillisiä rivejä kaikissa sarakkeissa.",
        "is": "Of mörg misheppnuð próf þar sem raðir voru ekki aðskildar yfir alla dálka.",
        "ar": "تجاوز وحدات الاختبار الفاشلة حيث لم تكن هناك صفوف متميزة عبر جميع الأعمدة.",
        "hi": "सभी स्तंभों में पंक्तियां पूरी तरह से अलग नहीं थीं, ऐसे असफल परीक्षण इकाइयों की अधिकता।",
        "el": "Υπέρβαση αποτυχημένων μονάδων δοκιμής όπου δεν υπήρχαν διακριτές γραμμές σε όλες τις στήλες.",
    },
    "across_row_distinct_expectation_text": {
        "en": "Expect entirely distinct rows across {column_text}.",
        "fr": "On s'attend à des lignes entièrement distinctes dans les colonnes {column_text}.",
        "de": "Erwarten Sie einzigartige Zeilen in {column_text}.",
        "it": "Aspettati righe completamente distinte su {column_text}.",
        "es": "Se esperan filas completamente distintas en {column_text}.",
        "pt": "Espea-se linhas completamente diferentes em {column_text}.",
        "ro": "Se așteaptă rânduri complet distincte în {column_text}.",
        "tr": "{column_text} boyunca tamamen farklı satırlar bekleyin.",
        "zh-Hans": "预期在列{column_text}，行应当完全不同（即无重复）。",
        "zh-Hant": "在{column_text}列中，不應出現重複的行。",
        "ja": "{column_text}において完全に異なる行を期待します。",
        "ko": "{column_text}에 걸쳐 완전히 고유한 행이 있어야 합니다.",
        "vi": "Kỳ vọng các hàng hoàn toàn khác biệt trên {column_text}.",
        "ru": "Ожидайте совершенно разные строки в {column_text}.",
        "cs": "Očekávají se úplně odlišné řádky napříč sloupci {column_text}.",
        "pl": "Spodziewaj się całkowicie odrębnych wierszy w {column_text}.",
        "da": "Forvent unikke værdier i alle rækker i {column_text}.",
        "sv": "Förvänta dig unika värden i alla rader i {column_text}.",
        "nb": "Forvent at rader er helt unike på tvers av {column_text}.",
        "nl": "Verwacht unieke regels in {column_text}.",
        "fi": "Odota täysin erillisiä rivejä sarakkeissa {column_text}.",
        "is": "Væntir þess að allar raðir séu aðskildar yfir {column_text}.",
        "ar": "توقع صفوف متميزة تمامًا عبر {column_text}.",
        "hi": "अपेक्षा है कि {column_text} में पंक्तियां पूरी तरह से अलग होनी चाहिए।",
        "el": "Αναμένεται πλήρως διακριτές γραμμές στις στήλες {column_text}.",
    },
    "across_row_distinct_failure_text": {
        "en": "Exceedance of failed test units where there weren't distinct rows across selected columns.",
        "fr": "Dépassement des unités de test ayant échoué là où il n'y avait pas des lignes distinctes dans les colonnes sélectionnées.",
        "de": "Überschreitung fehlgeschlagener Testeinheiten, bei denen in ausgewählten Spalten keine eindeutigen Zeilen vorhanden waren.",
        "it": "Superamento delle unità di test fallite in cui non c'erano righe distinte tra le colonne selezionate.",
        "es": "Se superó el número de unidades de prueba fallidas en que no hay filas distintas en las columnas seleccionadas.",
        "pt": "Excedeu o número de unidades de teste com falha onde não há linhas diferentes nas colunas selecionadas.",
        "ro": "Depășirea unităților de test eșuate unde nu au existat rânduri distincte în coloanele selectate.",
        "tr": "Seçili sütunlarda benzersiz satırların olmadığı başarısız test birimlerinin aşılması.",
        "zh-Hans": "错误过多，其中在所选列，行存在相同之处（即有重复）。",
        "zh-Hant": "錯誤過多，在所選擇的列中，有重複的行出現。",
        "ja": "選択された列において完全に異なる行でないテスト単位の失敗の超過。",
        "ko": "선택된 열에 걸쳐 고유한 행이 아니었던 실패한 테스트 단위 초과.",
        "vi": "Vượt quá số đơn vị kiểm tra thất bại trong đó các hàng không hoàn toàn khác biệt trên các cột đã chọn.",
        "ru": "Превышение неудачных тестовых блоков, где не было различных строк в выбранных столбцах.",
        "cs": "Překročení počtu neúspěšných testů, kde nebyly odlišné řádky napříč vybranými sloupci.",
        "pl": "Przekroczenie liczby niepomyślnych jednostek testowych, w których nie było odrębnych wierszy w wybranych kolumnach.",
        "da": "Overskridelse af antal fejlslagne enhedstests, hvor der ikke var unikke værdier i alle rækker i de valgte kolonner.",
        "sv": "Överstiger antalet misslyckade enhetstest där det inte fanns några unika värden i alla rader i de valda kolumnerna.",
        "nb": "Overskridelse av mislykkede testenheter hvor det ikke var unike rader på tvers av valgte kolonner.",
        "nl": "Overschrijding van mislukte testeenheden waarbij er geen afzonderlijke rijen waren over geselecteerde kolommen.",
        "fi": "Epäonnistuneiden testiyksikköjen ylitys, joissa ei ollut erillisiä rivejä valituissa sarakkeissa.",
        "is": "Of mörg misheppnuð próf þar sem raðir voru ekki aðskildar yfir valda dálka.",
        "ar": "تجاوز وحدات الاختبار الفاشلة حيث لم تكن هناك صفوف متميزة عبر الأعمدة المحددة.",
        "hi": "चयनित स्तंभों में पंक्तियां पूरी तरह से अलग नहीं थीं, ऐसे असफल परीक्षण इकाइयों की अधिकता।",
        "el": "Υπέρβαση αποτυχημένων μονάδων δοκιμής όπου δεν υπήρχαν διακριτές γραμμές στις επιλεγμένες στήλες.",
    },
    "all_row_complete_expectation_text": {
        "en": "Expect entirely complete rows across all columns.",
        "fr": "On s'attend à des lignes entièrement complètes dans toutes les colonnes.",
        "de": "Erwarten Sie vollständig komplette Zeilen über alle Spalten hinweg.",
        "it": "Aspettati righe completamente complete su tutte le colonne.",
        "es": "Se espera que las filas estén completamente completas en todas las columnas.",
        "pt": "Espera-se linhas completamente preenchidas em todas as colunas.",
        "ro": "Se așteaptă ca rândurile să fie complet complete în toate coloanele.",
        "tr": "Tüm sütunlarda tamamen eksiksiz satırlar bekleyin.",
        "zh-Hans": "预期所有列中的行都是完整的。",
        "zh-Hant": "預期所有列中的行都是完整的。",
        "ja": "すべての列で完全に完全な行を期待します。",
        "ko": "모든 열에서 완전히 완성된 행을 기대합니다.",
        "vi": "Kỳ vọng các hàng hoàn toàn đầy đủ trên tất cả các cột.",
        "ru": "Ожидайте полностью заполненные строки по всем столбцам.",
        "cs": "Očekávejte zcela kompletní řádky ve všech sloupcích.",
        "pl": "Spodziewaj się w pełni kompletnych wierszy we wszystkich kolumnach.",
        "da": "Forvent helt komplette rækker på tværs af alle kolonner.",
        "sv": "Förvänta dig helt kompletta rader över alla kolumner.",
        "nb": "Forvent helt komplette rader på tvers av alle kolonner.",
        "nl": "Verwacht volledig complete rijen in alle kolommen.",
        "fi": "Odota täysin täydellisiä rivejä kaikissa sarakkeissa.",
        "is": "Væntir þess að allar raðir séu heildstæðar yfir alla dálka.",
        "ar": "توقع صفوف مكتملة تمامًا عبر جميع الأعمدة.",
        "hi": "सभी स्तंभों में पूरी तरह से पूर्ण पंक्तियों की अपेक्षा करें।",
        "el": "Αναμένεται πλήρως ολοκληρωμένες γραμμές σε όλες τις στήλες.",
    },
    "all_row_complete_failure_text": {
        "en": "Exceedance of failed test units where there weren't complete rows across all columns.",
        "fr": "Dépassement des unités de test ayant échoué là où il n'y avait pas de lignes complètes dans toutes les colonnes.",
        "de": "Überschreitung fehlgeschlagener Testeinheiten, bei denen nicht vollständige Zeilen über alle Spalten hinweg vorhanden waren.",
        "it": "Superamento delle unità di test fallite in cui non c'erano righe complete su tutte le colonne.",
        "es": "Se superó el número de unidades de prueba fallidas donde no había filas completas en todas las columnas.",
        "pt": "Excedeu o número de unidades de teste com falha onde não havia linhas completas em todas as colunas.",
        "ro": "Depășirea unităților de test eșuate unde nu au existat rânduri complete în toate coloanele.",
        "tr": "Tüm sütunlarda eksiksiz satırların olmadığı başarısız test birimlerinin aşılması.",
        "zh-Hans": "错误过多，其中在所有列中行不完整。",
        "zh-Hant": "錯誤過多，在所有列中沒有完整的行。",
        "ja": "すべての列で完全な行がないテスト単位の失敗の超過。",
        "ko": "모든 열에 걸쳐 완전한 행이 아니었던 실패한 테스트 단위 초과.",
        "vi": "Vượt quá số đơn vị kiểm tra thất bại trong đó không có các hàng đầy đủ trên tất cả các cột.",
        "ru": "Превышение неудачных тестовых единиц, где не было полных строк по всем столбцам.",
        "cs": "Překročení počtu neúspěšných testů, kde nebyly úplné řádky ve všech sloupcích.",
        "pl": "Przekroczenie liczby niepomyślnych jednostek testowych, w których nie było kompletnych wierszy we wszystkich kolumnach.",
        "da": "Overskridelse af antal fejlslagne enhedstests, hvor der ikke var komplette rækker på tværs af alle kolonner.",
        "sv": "Överstiger antalet misslyckade enhetstest där det inte fanns kompletta rader över alla kolumner.",
        "nb": "Overskridelse av mislykkede testenheter hvor det ikke var komplette rader på tvers av alle kolonner.",
        "nl": "Overschrijding van mislukte testeenheden waarbij er geen complete rijen waren in alle kolommen.",
        "fi": "Epäonnistuneiden testiyksikköjen ylitys, joissa ei ollut täydellisiä rivejä kaikissa sarakkeissa.",
        "is": "Of mörg misheppnuð próf þar sem raðir voru ekki heildstæðar yfir alla dálka.",
        "ar": "تجاوز وحدات الاختبار الفاشلة حيث لم تكن هناك صفوف مكتملة عبر جميع الأعمدة.",
        "hi": "सभी स्तंभों में पूर्ण पंक्तियां नहीं थीं, ऐसे असफल परीक्षण इकाइयों की अधिकता।",
        "el": "Υπέρβαση αποτυχημένων μονάδων δοκιμής όπου δεν υπήρχαν πλήρεις γραμμές σε όλες τις στήλες.",
    },
    "across_row_complete_expectation_text": {
        "en": "Expect entirely complete rows across {column_text}.",
        "fr": "On s'attend à des lignes entièrement complètes dans {column_text}.",
        "de": "Erwarten Sie vollständig komplette Zeilen über {column_text} hinweg.",
        "it": "Aspettati righe completamente complete su {column_text}.",
        "es": "Se espera que las filas estén completamente completas en {column_text}.",
        "pt": "Espera-se linhas completamente preenchidas em {column_text}.",
        "ro": "Se așteaptă ca rândurile să fie complet complete în {column_text}.",
        "tr": "{column_text} boyunca tamamen eksiksiz satırlar bekleyin.",
        "zh-Hans": "预期在{column_text}中的行是完整的。",
        "zh-Hant": "預期在{column_text}中的行是完整的。",
        "ja": "{column_text}において完全に完全な行を期待します。",
        "ko": "{column_text}에서 완전히 완성된 행을 기대합니다.",
        "vi": "Kỳ vọng các hàng hoàn toàn đầy đủ trên {column_text}.",
        "ru": "Ожидайте полностью заполненные строки в {column_text}.",
        "cs": "Očekávejte zcela kompletní řádky v {column_text}.",
        "pl": "Spodziewaj się w pełni kompletnych wierszy w {column_text}.",
        "da": "Forvent helt komplette rækker på tværs af {column_text}.",
        "sv": "Förvänta dig helt kompletta rader över {column_text}.",
        "nb": "Forvent helt komplette rader på tvers av {column_text}.",
        "nl": "Verwacht volledig complete rijen in {column_text}.",
        "fi": "Odota täysin täydellisiä rivejä sarakkeissa {column_text}.",
        "is": "Væntir þess að allar raðir séu heildstæðar yfir {column_text}.",
        "ar": "توقع صفوف مكتملة تمامًا عبر {column_text}.",
        "hi": "{column_text} में पूरी तरह से पूर्ण पंक्तियों की अपेक्षा करें।",
        "el": "Αναμένεται πλήρως ολοκληρωμένες γραμμές στις στήλες {column_text}.",
    },
    "across_row_complete_failure_text": {
        "en": "Exceedance of failed test units where there weren't complete rows across selected columns.",
        "fr": "Dépassement des unités de test ayant échoué là où il n'y avait pas de lignes complètes dans les colonnes sélectionnées.",
        "de": "Überschreitung fehlgeschlagener Testeinheiten, bei denen nicht vollständige Zeilen über die ausgewählten Spalten hinweg vorhanden waren.",
        "it": "Superamento delle unità di test fallite in cui non c'erano righe complete nelle colonne selezionate.",
        "es": "Se superó el número de unidades de prueba fallidas donde no había filas completas en las columnas seleccionadas.",
        "pt": "Excedeu o número de unidades de teste com falha onde não havia linhas completas nas colunas selecionadas.",
        "ro": "Depășirea unităților de test eșuate unde nu au existat rânduri complete în coloanele selectate.",
        "tr": "Seçili sütunlarda eksiksiz satırların olmadığı başarısız test birimlerinin aşılması.",
        "zh-Hans": "错误过多，其中在所选列中行不完整。",
        "zh-Hant": "錯誤過多，在所選列中沒有完整的行。",
        "ja": "選択された列で完全な行がないテスト単位の失敗の超過。",
        "ko": "선택된 열에서 완전한 행이 아니었던 실패한 테스트 단위 초과.",
        "vi": "Vượt quá số đơn vị kiểm tra thất bại trong đó không có các hàng đầy đủ trên các cột đã chọn.",
        "ru": "Превышение неудачных тестовых единиц, где не было полных строк в выбранных столбцах.",
        "cs": "Překročení počtu neúspěšných testů, kde nebyly úplné řádky ve vybraných sloupcích.",
        "pl": "Przekroczenie liczby niepomyślnych jednostek testowych, w których nie było kompletnych wierszy w wybranych kolumnach.",
        "da": "Overskridelse af antal fejlslagne enhedstests, hvor der ikke var komplette rækker på tværs af valgte kolonner.",
        "sv": "Överstiger antalet misslyckade enhetstest där det inte fanns kompletta rader över valda kolumner.",
        "nb": "Overskridelse av mislykkede testenheter hvor det ikke var komplette rader på tvers av valgte kolonner.",
        "nl": "Overschrijding van mislukte testeenheden waarbij er geen complete rijen waren in geselecteerde kolommen.",
        "fi": "Epäonnistuneiden testiyksikköjen ylitys, joissa ei ollut täydellisiä rivejä valituissa sarakkeissa.",
        "is": "Of mörg misheppnuð próf þar sem raðir voru ekki heildstæðar yfir valda dálka.",
        "ar": "تجاوز وحدات الاختبار الفاشلة حيث لم تكن هناك صفوف مكتملة عبر الأعمدة المحددة.",
        "hi": "चयनित स्तंभों में पूर्ण पंक्तियां नहीं थीं, ऐसे असफल परीक्षण इकाइयों की अधिकता।",
        "el": "Υπέρβαση αποτυχημένων μονάδων δοκιμής όπου δεν υπήρχαν πλήρεις γραμμές στις επιλεγμένες στήλες.",
    },
    "col_schema_match_expectation_text": {
        "en": "Expect that column schemas match.",
        "fr": "On s'attend à ce que les schémas de colonnes correspondent.",
        "de": "Erwarten Sie, dass die Spaltenschemata übereinstimmen.",
        "it": "Aspettati che gli schemi di colonna corrispondano.",
        "es": "Se espera que los esquemas de columna coincidan.",
        "pt": "Espera-se que os esquemas de coluna concordem.",
        "ro": "Se așteaptă ca schemele coloanelor să se potrivească.",
        "tr": "Sütun şemalarının eşleşmesini bekleyin.",
        "zh-Hans": "预期列模式（column schemas）应当匹配。",
        "zh-Hant": "預期列模式（column schemas）應該匹配。",
        "ja": "列スキーマが一致することを期待します。",
        "ko": "열 스키마가 일치해야 합니다.",
        "vi": "Kỳ vọng các lược đồ cột phù hợp với nhau.",
        "ru": "Ожидайте, что схемы столбцов совпадают.",
        "cs": "Očekává se, že schémata sloupců se shodují.",
        "pl": "Spodziewaj się, że schematy kolumn będa zgodne.",
        "da": "Forvent overensstemmelse med kolonne schema.",
        "sv": "Förvänta överensstämmelse med kolumn schema.",
        "nb": "Forvent at kolonneskjemaer samsvarer.",
        "nl": "Verwacht dat de kolomschema's overeenkomen.",
        "fi": "Odota, että sarakkeiden skeemat täsmäävät.",
        "is": "Væntir þess að dálkaskema passi.",
        "ar": "توقع تطابق مخططات الأعمدة.",
        "hi": "अपेक्षा है कि स्तंभ योजनाएं मेल खानी चाहिए।",
        "el": "Αναμένεται τα σχήματα των στηλών να ταιριάζουν.",
    },
    "col_schema_match_failure_text": {
        "en": "Failure to validate that column schemas match.",
        "fr": "Échec de validation de la correspondance des schémas de colonne.",
        "de": "Fehler beim Überprüfen der übereinstimmen dieser Spaltenschemata.",
        "it": "Impossibile convalidare gli schemi di colonna corrispondenti.",
        "es": "Error al validar que coincidan los esquemas de columna.",
        "pt": "Erro ao validar que concordem os esquemas de coluna.",
        "ro": "Eșec la validarea potrivirii schemelor coloanelor.",
        "tr": "Sütun şemalarının eşleşmesinin doğrulanamaması.",
        "zh-Hans": "未成功确认列模式（column schemas）匹配。",
        "zh-Hant": "未成功確認列模式（column schemas）匹配。",
        "ja": "列スキーマが一致することを検証できませんでした。",
        "ko": "열 스키마가 일치하는지 검증 실패.",
        "vi": "Thất bại khi xác nhận rằng các lược đồ cột phù hợp với nhau.",
        "ru": "Неверка соответствия схем столбцов.",
        "cs": "Nepovedlo se ověřit, že schémata sloupců se shodují.",
        "pl": "Niepowodzenie weryfikacji zgodności schematów kolumn.",
        "da": "Fejl da der ikke er overensstemmelse med kolonne schema.",
        "sv": "Fel eftersom kolonnschemat inte matchar.",
        "nb": "Kunne ikke validere at kolonneskjemaer samsvarer.",
        "nl": "Het is mislukt om de overeenkomst van die kolomschema's te valideren.",
        "fi": "Sarakkeiden skeemojen täsmäävyyden vahvistaminen epäonnistui.",
        "is": "Mistókst að staðfesta að dálkaskema passi.",
        "ar": "فشل في التحقق من تطابق مخططات الأعمدة.",
        "hi": "स्तंभ योजनाओं के मेल खाने को सत्यापित करने में विफलता।",
        "el": "Αποτυχία επιβεβαίωσης ότι τα σχήματα των στηλών ταιριάζουν.",
    },
    "row_count_match_expectation_text": {
        "en": "Expect that row counts for two tables match.",
        "fr": "On s'attend à ce que le nombre de lignes soit égal pour deux tableaux.",
        "de": "Erwarten Sie, dass die Zeilenanzahl für zwei Tabellen gleich ist.",
        "it": "Si prevede che il conteggio delle righe per due tabelle corrisponda.",
        "es": "Se espera que coincidan los recuentos de filas de dos tablas.",
        "pt": "Espera-se que as contagens de linha para duas tabelas correspondam.",
        "ro": "Se așteaptă ca numărul de rânduri pentru două tabele să se potrivească.",
        "tr": "İki tablo için satır sayılarının eşit olmasını bekleyin.",
        "zh-Hans": "预计两个表的行数相等。",
        "zh-Hant": "兩張表內行數應該相等。",
        "ja": "2つのテーブルの行数が一致することを期待します。",
        "ko": "두 테이블의 행 수가 일치해야 합니다.",
        "vi": "Kỳ vọng số lượng hàng của hai bảng phải giống nhau.",
        "ru": "Ожидается, что количество строк в двух таблицах будет одинаковым.",
        "cs": "Očekává se, že počty řádků pro dvě tabulky se shodují.",
        "pl": "Oczekuje się, że liczby wierszy są równe dla dwóch tabel.",
        "da": "Forvent, at rækkeantallet er ens for to tabeller.",
        "sv": "Räkna med att radantalet är lika för två tabeller.",
        "nb": "Forvent at antall rader for to tabeller samsvarer.",
        "nl": "Verwacht dat het aantal rijen gelijk is voor twee tabellen.",
        "fi": "Odota, että kahden taulun rivimäärät täsmäävät.",
        "is": "Væntir þess að raðafjöldi tveggja taflna passi.",
        "ar": "توقع تطابق عدد الصفوف للجدولين.",
        "hi": "अपेक्षा है कि दो तालिकाओं की पंक्ति संख्या मेल खानी चाहिए।",
        "el": "Αναμένεται ο αριθμός γραμμών για τους δύο πίνακες να ταιριάζει.",
    },
    "row_count_match_failure_text": {
        "en": "Row counts for the two tables did not match.",
        "fr": "Le nombre de lignes pour les deux tableaux ne correspondait pas.",
        "de": "Die Zeilenanzahl für die beiden Tabellen stimmte nicht überein.",
        "it": "Il conteggio delle righe per le due tabelle non corrispondeva.",
        "es": "Los recuentos de filas de las dos tablas no coincidían.",
        "pt": "As contagens de linhas para as duas tabelas não corresponderam.",
        "ro": "Numărul de rânduri pentru cele două tabele nu s-a potrivit.",
        "tr": "İki tablo için satır sayıları eşleşmedi.",
        "zh-Hans": "两个表的行数不匹配。",
        "zh-Hant": "兩張表內行數不相等。",
        "ja": "2つのテーブルの行数が一致しませんでした。",
        "ko": "두 테이블의 행 수가 일치하지 않았습니다.",
        "vi": "Số lượng hàng của hai bảng không giống nhau.",
        "ru": "Количество строк для двух таблиц не совпало.",
        "cs": "Počty řádků pro dvě tabulky se neshodovaly.",
        "pl": "Liczba wierszy dla dwóch tabel nie zgadzała się.",
        "da": "Rækketællinger for de to tabeller stemte ikke overens.",
        "sv": "Antal rader för de två borden stämde inte överens.",
        "nb": "Antall rader for de to tabellene samsvarte ikke.",
        "nl": "Het aantal rijen voor de twee tafels kwam niet overeen.",
        "fi": "Kahden taulun rivimäärät eivät täsmänneet.",
        "is": "Raðafjöldi tveggja taflna passaði ekki.",
        "ar": "لم يتطابق عدد الصفوف للجدولين.",
        "hi": "दो तालिकाओं की पंक्ति संख्या मेल नहीं खाती।",
        "el": "Ο αριθμός γραμμών για τους δύο πίνακες δεν ταίριαζε.",
    },
    "row_count_match_n_expectation_text": {
        "en": "Expect that the row count is exactly {values_text}.",
        "fr": "On s'attend à ce que le nombre de lignes soit exactement de {values_text}.",
        "de": "Erwarten Sie, dass die Zeilenzahl genau {values_text} beträgt.",
        "it": "Aspettatevi che il conteggio delle righe sia esattamente {values_text}.",
        "es": "Espera que el recuento de filas sea exactamente {values_text}.",
        "pt": "Esperar que a contagem das filas seja exactamente {values_text}.",
        "ro": "Se așteaptă ca numărul de rânduri să fie exact {values_text}.",
        "tr": "Satır sayısının tam olarak {values_text} olmasını bekleyin.",
        "zh-Hans": "期望行数正好是{values_text}。",
        "zh-Hant": "行數應該正好為{values_text}。",
        "ja": "行数がちょうど{values_text}であることを期待します。",
        "ko": "행 수가 정확히 {values_text}이어야 합니다.",
        "vi": "Kỳ vọng số lượng hàng phải đúng bằng {values_text}.",
        "ru": "Ожидайте, что количество строк будет ровно {values_text}.",
        "cs": "Očekává se, že počet řádků je přesně {values_text}.",
        "pl": "Oczekuj, że liczba wierszy wynosi dokładnie {values_text}.",
        "da": "Forvent, at antallet af rækker er præcis {values_text}.",
        "sv": "Förvänta dig att antalet rader är exakt {values_text}.",
        "nb": "Forvent at antall rader er nøyaktig {values_text}.",
        "nl": "Verwacht dat het rijtal precies {values_text} is.",
        "fi": "Odota, että rivimäärä on tasan {values_text}.",
        "is": "Væntir þess að raðafjöldi sé nákvæmlega {values_text}.",
        "ar": "توقع أن يكون عدد الصفوف بالضبط {values_text}.",
        "hi": "अपेक्षा है कि पंक्ति संख्या बिल्कुल {values_text} होनी चाहिए।",
        "el": "Αναμένεται ο αριθμός γραμμών να είναι ακριβώς {values_text}.",
    },
    "row_count_match_n_failure_text": {
        "en": "The row count did not match {values_text}.",
        "fr": "Le nombre de lignes ne correspond pas à {values_text}.",
        "de": "Die Zeilenzahl stimmte nicht mit {values_text} überein.",
        "it": "Il conteggio delle righe non corrisponde a {values_text}.",
        "es": "El recuento de filas no coincide con {values_text}.",
        "pt": "A contagem das filas não correspondeu a {values_text}.",
        "ro": "Numărul de rânduri nu a corespuns cu {values_text}.",
        "tr": "Satır sayısı {values_text} ile eşleşmedi.",
        "zh-Hans": "行数不符合{values_text}。",
        "zh-Hant": "行數與{values_text}不相等。",
        "ja": "行数が{values_text}と一致しませんでした。",
        "ko": "행 수가 {values_text}와 일치하지 않았습니다.",
        "vi": "Số lượng hàng không khớp với {values_text}.",
        "ru": "Количество строк не соответствует {values_text}.",
        "cs": "Počet řádků neodpovídal {values_text}.",
        "pl": "Liczba wierszy nie zgadzała się z {values_text}.",
        "da": "Antallet af rækker svarede ikke til {values_text}.",
        "sv": "Antalet rader stämde inte överens med {values_text}.",
        "nb": "Antall rader samsvarte ikke med {values_text}.",
        "nl": "Het rijtal kwam niet overeen met {values_text}.",
        "fi": "Rivimäärä ei vastannut arvoa {values_text}.",
        "is": "Raðafjöldi passaði ekki við {values_text}.",
        "ar": "لم يتطابق عدد الصفوف مع {values_text}.",
        "hi": "पंक्ति संख्या {values_text} से मेल नहीं खाती।",
        "el": "Ο αριθμός γραμμών δεν ταίριαζε με το {values_text}.",
    },
    "col_count_match_expectation_text": {
        "en": "Expect that column counts for two tables match.",
        "fr": "On s'attend à ce que le nombre de colonnes de deux tableaux corresponde.",
        "de": "Erwarten Sie, dass die Spaltenzahlen für zwei Tabellen übereinstimmen.",
        "it": "Aspettatevi che i conteggi delle colonne per due tabelle corrispondano.",
        "es": "Se espera que los recuentos de columnas de dos tablas coincidan.",
        "pt": "Esperar que a contagem das colunas para duas tabelas coincidam.",
        "ro": "Se așteaptă ca numărul de coloane pentru două tabele să se potrivească.",
        "tr": "Bu sütunun iki tablo eşleşmesi için sayılmasını bekleyin.",
        "zh-Hans": "期望两个表的列数能匹配。",
        "zh-Hant": "兩張表內列數應該相等。",
        "ja": "2つのテーブルの列数が一致することを期待します。",
        "ko": "두 테이블의 열 수가 일치해야 합니다.",
        "vi": "Kỳ vọng số lượng cột của hai bảng phải giống nhau.",
        "ru": "Ожидайте, что количество столбцов в двух таблицах совпадает.",
        "cs": "Očekává se, že počty sloupců pro dvě tabulky se shodují.",
        "pl": "Oczekuj, że liczby kolumn dla dwóch tabel będą się zgadzać.",
        "da": "Forventer, at kolonnetallene for to tabeller stemmer overens.",
        "sv": "Förvänta dig att kolumnantalet för två tabeller är detsamma.",
        "nb": "Forvent at antall kolonner for to tabeller samsvarer.",
        "nl": "Verwacht dat kolomtellingen voor twee tabellen overeenkomen.",
        "fi": "Odota, että kahden taulun sarakemäärät täsmäävät.",
        "is": "Væntir þess að dálkafjöldi tveggja taflna passi.",
        "ar": "توقع تطابق عدد الأعمدة للجدولين.",
        "hi": "अपेक्षा है कि दो तालिकाओं की स्तंभ संख्या मेल खानी चाहिए।",
        "el": "Αναμένεται ο αριθμός στηλών για τους δύο πίνακες να ταιριάζει.",
    },
    "col_count_match_failure_text": {
        "en": "Column counts for the two tables did not match.",
        "fr": "Le nombre de colonnes des deux tableaux ne correspond pas.",
        "de": "Die Spaltenzahlen der beiden Tabellen stimmten nicht überein.",
        "it": "I conteggi delle colonne per le due tabelle non corrispondono.",
        "es": "Los recuentos de las columnas de las dos tablas no coinciden.",
        "pt": "As contagens das colunas para as duas tabelas não coincidiram.",
        "ro": "Numărul de coloane pentru cele două tabele nu s-a potrivit.",
        "tr": "İki tablo için sütun sayıları eşleşmedi.",
        "zh-Hans": "两张表的列数并不匹配。",
        "zh-Hant": "兩張表內列數不相等。",
        "ja": "2つのテーブルの列数が一致しませんでした。",
        "ko": "두 테이블의 열 수가 일치하지 않았습니다.",
        "vi": "Số lượng cột của hai bảng không giống nhau.",
        "ru": "Количество колонок в двух таблицах не совпадает.",
        "cs": "Počty sloupců pro dvě tabulky se neshodovaly.",
        "pl": "Liczby kolumn w obu tabelach nie zgadzały się.",
        "da": "Kolonnetællingerne for de to tabeller stemte ikke overens.",
        "sv": "Kolumnantalet i de två tabellerna stämde inte överens.",
        "nb": "Antall kolonner for de to tabellene samsvarte ikke.",
        "nl": "Kolomtellingen voor de twee tabellen kwamen niet overeen.",
        "fi": "Kahden taulun sarakemäärät eivät täsmänneet.",
        "is": "Dálkafjöldi tveggja taflna passaði ekki.",
        "ar": "لم يتطابق عدد الأعمدة للجدولين.",
        "hi": "दो तालिकाओं की स्तंभ संख्या मेल नहीं खाती।",
        "el": "Ο αριθμός στηλών για τους δύο πίνακες δεν ταίριαζε.",
    },
    "col_count_match_n_expectation_text": {
        "en": "Expect that the column count is exactly {values_text}.",
        "fr": "On s'attend à ce que le nombre de colonnes soit exactement de {values_text}.",
        "de": "Erwarten Sie, dass die Anzahl der Spalten genau {values_text} beträgt.",
        "it": "Aspettatevi che il numero di colonne sia esattamente {values_text}.",
        "es": "Espera que el recuento de columnas sea exactamente {values_text}.",
        "pt": "Esperar que a contagem da coluna seja exactamente {values_text}.",
        "ro": "Se așteaptă ca numărul de coloane să fie exact {values_text}.",
        "tr": "Sütun sayısının tam olarak {values_text} olmasını bekleyin.",
        "zh-Hans": "期望列数正好是{values_text}。",
        "zh-Hant": "列數應該正好為{values_text}。",
        "ja": "列数がちょうど{values_text}であることを期待します。",
        "ko": "열 수가 정확히 {values_text}이어야 합니다.",
        "vi": "Kỳ vọng số lượng cột phải đúng bằng {values_text}.",
        "ru": "Ожидайте, что количество столбцов будет ровно {values_text}.",
        "cs": "Očekává se, že počet sloupců je přesně {values_text}.",
        "pl": "Oczekuj, że liczba kolumn będzie wynosić dokładnie {values_text}.",
        "da": "Forvent, at kolonnetallet er præcis {values_text}.",
        "sv": "Förvänta dig att antalet kolumner är exakt {values_text}.",
        "nb": "Forvent at antall kolonner er nøyaktig {values_text}.",
        "nl": "Verwacht dat het aantal kolommen precies {values_text} is.",
        "fi": "Odota, että sarakemäärä on tasan {values_text}.",
        "is": "Væntir þess að dálkafjöldi sé nákvæmlega {values_text}.",
        "ar": "توقع أن يكون عدد الأعمدة بالضبط {values_text}.",
        "hi": "अपेक्षा है कि स्तंभ संख्या बिल्कुल {values_text} होनी चाहिए।",
        "el": "Αναμένεται ο αριθμός στηλών να είναι ακριβώς {values_text}.",
    },
    "col_count_match_n_failure_text": {
        "en": "The column count did not match {values_text}.",
        "fr": "Le nombre de colonnes ne correspondait pas à {values_text}.",
        "de": "Die Anzahl der Spalten stimmte nicht mit {values_text} überein.",
        "it": "Il conteggio delle colonne non corrisponde a {values_text}.",
        "es": "El recuento de columnas no coincide con {values_text}.",
        "pt": "A contagem de colunas não correspondeu a {values_text}.",
        "ro": "Numărul de coloane nu a corespuns cu {values_text}.",
        "tr": "Sütun sayısı {values_text} ile eşleşmedi.",
        "zh-Hans": "列数与{values_text}不匹配。",
        "zh-Hant": "列數與{values_text}不相等。",
        "ja": "列数が{values_text}と一致しませんでした。",
        "ko": "열 수가 {values_text}와 일치하지 않았습니다.",
        "vi": "Số lượng cột không khớp với {values_text}.",
        "ru": "Количество столбцов не соответствует {values_text}.",
        "cs": "Počet sloupců neodpovídal {values_text}.",
        "pl": "Liczba kolumn nie jest zgodna z liczbą {values_text}.",
        "da": "Kolonnetallet svarede ikke til {values_text}.",
        "sv": "Antalet kolumner stämde inte överens med {values_text}.",
        "nb": "Antall kolonner samsvarte ikke med {values_text}.",
        "nl": "De kolomtelling kwam niet overeen met {values_text}.",
        "fi": "Sarakemäärä ei vastannut arvoa {values_text}.",
        "is": "Dálkafjöldi passaði ekki við {values_text}.",
        "ar": "لم يتطابق عدد الأعمدة مع {values_text}.",
        "hi": "स्तंभ संख्या {values_text} से मेल नहीं खाती।",
        "el": "Ο αριθμός στηλών δεν ταίριαζε με το {values_text}.",
    },
    "conjointly_expectation_text": {
        "en": "Expect conjoint 'pass' units across all expressions.",
        "fr": "On s'attend à des unités 'réussite' conjointes sur toutes les expressions.",
        "de": "Erwarten Sie gemeinsame 'Bestanden'-Einheiten über alle Ausdrücke hinweg.",
        "it": "Aspettatevi unità 'pass' congiunte su tutte le espressioni.",
        "es": "Se esperan unidades 'aprobadas' conjuntas en todas las expresiones.",
        "pt": "Espera-se unidades 'aprovadas' conjuntas em todas as expressões.",
        "ro": "Se așteaptă unități 'pass' comune în toate expresiile.",
        "tr": "Tüm ifadeler boyunca birleşik 'geçen' birimler bekleyin.",
        "zh-Hans": "预期所有表达式中都有共同的'通过'单元。",
        "zh-Hant": "預期所有表達式中都有共同的'通過'單元。",
        "ja": "全ての表現にわたって結合された'合格'ユニットを期待します。",
        "ko": "모든 표현식에 걸쳐 결합된 '통과' 단위를 기대합니다.",
        "vi": "Kỳ vọng các đơn vị 'đạt' kết hợp trên tất cả các biểu thức.",
        "ru": "Ожидайте совместные единицы 'прохождения' по всем выражениям.",
        "cs": "Očekávejte společné 'úspěšné' jednotky ve všech výrazech.",
        "pl": "Oczekuj wspólnych jednostek 'zaliczonych' we wszystkich wyrażeniach.",
        "da": "Forvent fælles 'godkendte' enheder på tværs af alle udtryk.",
        "sv": "Förvänta dig gemensamma 'godkända' enheter över alla uttryck.",
        "nb": "Forvent felles 'godkjente' enheter på tvers av alle uttrykk.",
        "nl": "Verwacht gezamenlijke 'geslaagde' eenheden over alle expressies.",
        "fi": "Odota yhteisiä 'läpäisseitä' yksiköitä kaikissa lausekkeissa.",
        "is": "Væntir sameiginlegra 'staðinna' eininga yfir allar segðir.",
        "ar": "توقع وحدات 'ناجحة' مشتركة عبر جميع التعبيرات.",
        "hi": "सभी अभिव्यक्तियों में संयुक्त 'पास' इकाइयों की अपेक्षा करें।",
        "el": "Αναμένονται κοινές μονάδες 'επιτυχίας' σε όλες τις εκφράσεις.",
    },
    "conjointly_failure_text": {
        "en": "Exceedance of failed test units where there should have been conjoint 'pass' units.",
        "fr": "Dépassement des unités de test ayant échoué où il aurait dû y avoir des unités 'réussite' conjointes.",
        "de": "Überschreitung fehlgeschlagener Testeinheiten, bei denen es gemeinsame 'Bestanden'-Einheiten hätte geben sollen.",
        "it": "Superamento di unità di test fallite dove ci sarebbero dovute essere unità 'pass' congiunte.",
        "es": "Se superó el número de unidades de prueba fallidas donde debería haber habido unidades 'aprobadas' conjuntas.",
        "pt": "Excedeu o número de unidades de teste com falha onde deveria haver unidades 'aprovadas' conjuntas.",
        "ro": "Depășirea unităților de test eșuate unde ar fi trebuit să existe unități 'pass' comune.",
        "tr": "Birleşik 'geçen' birimler olması gereken yerlerde başarısız test birimlerinin aşılması.",
        "zh-Hans": "错误过多，其中应当有共同的'通过'单元。",
        "zh-Hant": "錯誤過多，其中應該有共同的'通過'單元。",
        "ja": "結合された'合格'ユニットがあるはずの場所でのテスト単位の失敗の超過。",
        "ko": "결합된 '통과' 단위가 있어야 했던 실패한 테스트 단위 초과.",
        "vi": "Vượt quá số đơn vị kiểm tra thất bại trong đó đáng lẽ phải có các đơn vị 'đạt' kết hợp.",
        "ru": "Превышение неудачных тестовых единиц, где должны были быть совместные единицы 'прохождения'.",
        "cs": "Překročení počtu neúspěšných testovacích jednotek, kde měly být společné 'úspěšné' jednotky.",
        "pl": "Przekroczenie nieudanych jednostek testowych, gdzie powinny były być wspólne jednostki 'zaliczone'.",
        "da": "Overskridelse af fejlslagne testenheder, hvor der skulle have været fælles 'godkendte' enheder.",
        "sv": "Överskrider antalet misslyckade testenheter där det borde ha funnits gemensamma 'godkända' enheter.",
        "nb": "Overskridelse av mislykkede testenheter hvor det skulle ha vært felles 'godkjente' enheter.",
        "nl": "Overschrijding van mislukte testeenheden waar gezamenlijke 'geslaagde' eenheden hadden moeten zijn.",
        "fi": "Epäonnistuneiden testiyksiköiden ylitys, joissa olisi pitänyt olla yhteisiä 'läpäisseitä' yksiköitä.",
        "is": "Of mörg misheppnuð próf þar sem hefðu átt að vera sameiginlegar 'staðnar' einingar.",
        "ar": "تجاوز وحدات الاختبار الفاشلة حيث كان يجب أن تكون هناك وحدات 'ناجحة' مشتركة.",
        "hi": "असफल परीक्षण इकाइयों की अधिकता जहां संयुक्त 'पास' इकाइयां होनी चाहिए थीं।",
        "el": "Υπέρβαση αποτυχημένων μονάδων δοκιμής όπου θα έπρεπε να υπάρχουν κοινές μονάδες 'επιτυχίας'.",
    },
    "specially_expectation_text": {
        "en": "Expect that special testing with a given function yields agreement.",
        "fr": "On s'attend à ce que les tests spéciaux avec une fonction donnée produisent un accord.",
        "de": "Erwarten Sie, dass spezielle Tests mit einer bestimmten Funktion Übereinstimmung ergeben.",
        "it": "Aspettati che i test speciali con una funzione data producano accordo.",
        "es": "Se espera que las pruebas especiales con una función dada produzcan concordancia.",
        "pt": "Espera-se que testes especiais com uma função dada produzam concordância.",
        "ro": "Se așteaptă ca testarea specială cu o funcție dată să producă acord.",
        "tr": "Belirli bir fonksiyonla özel testlerin uyum sağlamasını bekleyin.",
        "zh-Hans": "预期使用给定函数的特殊测试会产生一致结果。",
        "zh-Hant": "預期使用給定函數的特殊測試會產生一致結果。",
        "ja": "指定された関数による特別なテストが一致することを期待します。",
        "ko": "주어진 함수로 특수 테스트를 수행하면 일치함을 기대합니다.",
        "vi": "Kỳ vọng rằng kiểm tra đặc biệt với một hàm đã cho sẽ cho kết quả phù hợp.",
        "ru": "Ожидайте, что специальное тестирование с заданной функцией дает согласие.",
        "cs": "Očekává se, že speciální testování s danou funkcí přinese shodu.",
        "pl": "Oczekuj, że specjalne testowanie z użyciem danej funkcji przyniesie zgodność.",
        "da": "Forvent at speciel test med en given funktion giver overensstemmelse.",
        "sv": "Förvänta dig att speciell testning med en given funktion ger överensstämmelse.",
        "nb": "Forvent at spesiell testing med en gitt funksjon gir samsvar.",
        "nl": "Verwacht dat speciale tests met een gegeven functie overeenstemming opleveren.",
        "fi": "Odota, että erityinen testaus annetulla funktiolla tuottaa yhdenmukaisuuden.",
        "is": "Væntir þess að sérstök prófun með gefnu falli leiði til samræmis.",
        "ar": "توقع أن الاختبار الخاص بدالة معينة يؤدي إلى التوافق.",
        "hi": "अपेक्षा है कि दिए गए फ़ंक्शन के साथ विशेष परीक्षण सहमति प्रदान करेगा।",
        "el": "Αναμένεται ότι ο ειδικός έλεγχος με μια δεδομένη συνάρτηση αποδίδει συμφωνία.",
    },
    "specially_failure_text": {
        "en": "Exceedance of failed test units when performing specialized testing with a given function.",
        "fr": "Dépassement des unités de test ayant échoué lors de l'exécution de tests spécialisés avec une fonction donnée.",
        "de": "Überschreitung fehlgeschlagener Testeinheiten bei der Durchführung spezialisierter Tests mit einer bestimmten Funktion.",
        "it": "Superamento delle unità di test fallite durante l'esecuzione di test specializzati con una funzione data.",
        "es": "Se superó el número de unidades de prueba fallidas al realizar pruebas especializadas con una función dada.",
        "pt": "Excedeu o número de unidades de teste com falha ao realizar testes especializados com uma função dada.",
        "ro": "Depășirea unităților de test eșuate la efectuarea testării specializate cu o funcție dată.",
        "tr": "Belirli bir fonksiyonla özel testler yapılırken başarısız test birimlerinin aşılması.",
        "zh-Hans": "使用给定函数进行专门测试时，失败的测试单元数量超标。",
        "zh-Hant": "使用給定函數進行專門測試時，失敗的測試單元數量超標。",
        "ja": "指定された関数を使用した特殊テスト実行時のテスト単位の失敗の超過。",
        "ko": "주어진 함수로 특수 테스트를 수행할 때 실패한 테스트 단위 초과.",
        "vi": "Vượt quá số đơn vị kiểm tra thất bại khi thực hiện kiểm tra chuyên biệt với một hàm đã cho.",
        "ru": "Превышение неудачных тестовых единиц при выполнении специализированного тестирования с заданной функцией.",
        "cs": "Překročení počtu neúspěšných testovacích jednotek při provádění specializovaného testování s danou funkcí.",
        "pl": "Przekroczenie nieudanych jednostek testowych podczas przeprowadzania specjalistycznych testów z daną funkcją.",
        "da": "Overskridelse af fejlslagne testenheder ved udførelse af specialiseret test med en given funktion.",
        "sv": "Överskrider antalet misslyckade testenheter vid utförande av specialiserad testning med en given funktion.",
        "nb": "Overskridelse av mislykkede testenheter ved utførelse av spesialisert testing med en gitt funksjon.",
        "nl": "Overschrijding van mislukte testeenheden bij het uitvoeren van gespecialiseerde tests met een gegeven functie.",
        "fi": "Epäonnistuneiden testiyksiköiden ylitys suoritettaessa erikoistestejä annetulla funktiolla.",
        "is": "Of mörg misheppnuð próf við framkvæmd sérhæfðra prófana með gefnu falli.",
        "ar": "تجاوز وحدات الاختبار الفاشلة عند إجراء اختبار متخصص بدالة معينة.",
        "hi": "दिए गए फ़ंक्शन के साथ विशेष परीक्षण करते समय असफल परीक्षण इकाइयों की अधिकता।",
        "el": "Υπέρβαση αποτυχημένων μονάδων δοκιμής κατά την εκτέλεση εξειδικευμένων ελέγχων με μια δεδομένη συνάρτηση.",
    },
}


VALIDATION_REPORT_TEXT = {
    "pointblank_validation_title_text": {
        "en": "Pointblank Validation",
        "fr": "Validation Pointblank",
        "de": "Pointblank-Validierung",
        "it": "Convalida Pointblank",
        "es": "Validación de Pointblank",
        "pt": "Validação de Pointblank",
        "ro": "Validare Pointblank",
        "tr": "Pointblank Doğrulama",
        "zh-Hans": "Pointblank检验",
        "zh-Hant": "Pointblank驗證",
        "ja": "Pointblankバリデーション",
        "ko": "Pointblank 검증",
        "vi": "Kiểm Định Pointblank",
        "ru": "Проверка Pointblank",
        "cs": "Pointblank Validace",
        "pl": "Walidacja Pointblank",
        "da": "Pointblank Validering",
        "sv": "Pointblank Validation",
        "nb": "Pointblank Validering",
        "nl": "Pointblank-validatie",
        "fi": "Pointblank-validointi",
        "is": "Pointblank Gildisstaðfesting",
        "ar": "تحقق بوينتبلانك",
        "hi": "पॉइंटब्लैंक सत्यापन",
        "el": "Επικύρωση Pointblank",
    },
    "pointblank_validation_plan_text": {
        "en": "Pointblank Validation Plan",
        "fr": "Plan de validation de Pointblank",
        "de": "Pointblank-Validierungsplan",
        "it": "Piano di convalida Pointblank",
        "es": "Plan de validación de Pointblank",
        "pt": "Plano de Validação Pointblank",
        "ro": "Plan de Validare Pointblank",
        "tr": "Pointblank Doğrulama Planı",
        "zh-Hans": "Pointblank检验计划",
        "zh-Hant": "Pointblank驗證計劃",
        "ja": "Pointblankバリデーション計画",
        "ko": "Pointblank 검증 계획",
        "vi": "Kế Hoạch Kiểm Định Pointblank",
        "ru": "План проверки Pointblank",
        "cs": "Pointblank Validační Plán",
        "pl": "Plan walidacji Pointblank",
        "da": "Pointblank Validerings Plan",
        "sv": "Pointblank Validation Plan",
        "nb": "Pointblank Valideringsplan",
        "nl": "Pointblank-validatieplan",
        "fi": "Pointblank-validointisuunnitelma",
        "is": "Pointblank Gildisstaðfestingaráætlun",
        "ar": "خطة تحقق بوينتبلانك",
        "hi": "पॉइंटब्लैंक सत्यापन योजना",
        "el": "Σχέδιο Επικύρωσης Pointblank",
    },
    "no_interrogation_performed_text": {
        "en": "No Interrogation Performed",
        "fr": "Aucune interrogation effectuée",
        "de": "Keine Abfrage durchgeführt",
        "it": "Nessuna interrogazione eseguita",
        "es": "No se realizaron interrogatorios",
        "pt": "Não foram realizados interrogatórios",
        "ro": "Nicio Interogare Efectuată",
        "tr": "Sorgulama Yapılmadı",
        "zh-Hans": "未采用问询",
        "zh-Hant": "未執行查詢",
        "ja": "検証が実行されていません",
        "ko": "검증 수행되지 않음",
        "vi": "Không Thực Hiện Kiểm Tra",
        "ru": "Допрос не производился",
        "cs": "Nebyla provedena žádná kontrola",
        "pl": "Żadne zapytanie nie zostało wykonane",
        "da": "Intet forhør foretaget",
        "sv": "Inga förhör genomfördes",
        "nb": "Ingen interrogasjon utført",
        "nl": "Geen ondervraging uitgevoerd",
        "fi": "Kyselyä ei suoritettu",
        "is": "Engin yfirheyrsla framkvæmd",
        "ar": "لم يتم إجراء استجواب",
        "hi": "कोई पूछताछ नहीं की गई",
        "el": "Δεν πραγματοποιήθηκε ερώτηση",
    },
    "no_validation_steps_text": {
        "en": "NO VALIDATION STEPS",
        "fr": "AUCUNE ÉTAPE DE VALIDATION",
        "de": "KEINE VALIDIERUNGSSCHRITTE",
        "it": "NESSUNA FASE DI CONVALIDA",
        "es": "SIN PASOS DE VALIDACIÓN",
        "pt": "SEM ETAPAS DE VALIDAÇÃO",
        "ro": "FĂRĂ PAȘI DE VALIDARE",
        "tr": "DOĞRULAMA ADIMI YOK",
        "zh-Hans": "无验证步骤",
        "zh-Hant": "無驗證步驟",
        "ja": "検証ステップがありません",
        "ko": "검증 단계 없음",
        "vi": "KHÔNG CÓ BƯỚC KIỂM ĐỊNH",
        "ru": "НЕТ ШАГОВ ПРОВЕРКИ",
        "cs": "ŽÁDNÉ VALIDAČNÍ KROKY",
        "pl": "BRAK KROKÓW WALIDACJI",
        "da": "INGEN VALIDERINGSTRIN",
        "sv": "INGA VALIDERINGSSTEG",
        "nb": "INGEN VALIDERINGSTRINN",
        "nl": "GEEN VALIDATIESTAPPEN",
        "fi": "EI VALIDOINTIVAIHEITA",
        "is": "ENGIN GILDISSTAÐFESTINGARSKREF",
        "ar": "لا توجد خطوات تحقق",
        "hi": "कोई सत्यापन चरण नहीं",
        "el": "ΧΩΡΙΣ ΒΗΜΑΤΑ ΕΠΙΚΥΡΩΣΗΣ",
    },
    "use_validation_methods_text": {
        "en": "Use validation methods to add steps to the validation plan.",
        "fr": "Utilisez les méthodes de validation pour ajouter des étapes au plan de validation.",
        "de": "Verwenden Sie Validierungsmethoden, um dem Validierungsplan Schritte hinzuzufügen.",
        "it": "Utilizzare i metodi di convalida per aggiungere passaggi al piano di convalida.",
        "es": "Utilice métodos de validación para agregar pasos al plan de validación.",
        "pt": "Use métodos de validação para adicionar etapas ao plano de validação.",
        "ro": "Utilizați metodele de validare pentru a adăuga pași la planul de validare.",
        "tr": "Doğrulama planına adımlar eklemek için doğrulama yöntemlerini kullanın.",
        "zh-Hans": "使用验证方法向验证计划添加步骤。",
        "zh-Hant": "使用驗證方法向驗證計劃添加步驟。",
        "ja": "検証メソッドを使用して検証計画にステップを追加します。",
        "ko": "검증 메서드를 사용하여 검증 계획에 단계를 추가하세요.",
        "vi": "Sử dụng các phương thức kiểm định để thêm các bước vào kế hoạch kiểm định.",
        "ru": "Используйте методы проверки, чтобы добавить шаги в план проверки.",
        "cs": "Použijte metody validace pro přidání kroků do validačního plánu.",
        "pl": "Użyj metod walidacji, aby dodać kroki do planu walidacji.",
        "da": "Brug valideringsmetoder til at tilføje trin til valideringsplanen.",
        "sv": "Använd valideringsmetoder för att lägga till steg i valideringsplanen.",
        "nb": "Bruk valideringsmetoder for å legge til trinn i valideringsplanen.",
        "nl": "Gebruik validatiemethoden om stappen toe te voegen aan het validatieplan.",
        "fi": "Käytä validointimenetelmiä lisätäksesi vaiheita validointisuunnitelmaan.",
        "is": "Notaðu gildisstaðfestingaraðferðir til að bæta skrefum við gildisstaðfestingaráætlunina.",
        "ar": "استخدم طرق التحقق لإضافة خطوات إلى خطة التحقق.",
        "hi": "सत्यापन योजना में चरण जोड़ने के लिए सत्यापन विधियों का उपयोग करें।",
        "el": "Χρησιμοποιήστε μεθόδους επικύρωσης για να προσθέσετε βήματα στο σχέδιο επικύρωσης.",
    },
    "report_fail_rows_available": {
        "en": "There are {fail_rows_extract} 'fail' rows available as a CSV file.",
        "fr": "Il existe des {fail_rows_extract} lignes 'fail' disponibles sous forme de fichier CSV.",
        "de": "Es sind {fail_rows_extract} 'fail'-Zeilen als CSV-Datei verfügbar.",
        "it": "Sono disponibili {fail_rows_extract} righe 'fail' come file CSV.",
        "es": "Hay {fail_rows_extract} filas 'fail' disponibles como archivo CSV.",
        "pt": "Há {fail_rows_extract} linhas 'fail' disponíveis como um arquivo CSV.",
        "ro": "Există {fail_rows_extract} rânduri 'eșuate' disponibile ca fișier CSV.",
        "tr": "CSV dosyası olarak kullanılabilen {fail_rows_extract} 'fail' satırı var.",
        "zh-Hans": "有 {fail_rows_extract} “fail”可以作为一个CSV文件行。",
        "zh-Hant": "有 {fail_rows_extract} 筆「失敗」的資料列可作為CSV檔案。",
        "ja": "{fail_rows_extract}の'失敗'行がCSVファイルとして利用可能です。",
        "ko": "CSV 파일로 사용 가능한 {fail_rows_extract}개의 '실패' 행이 있습니다.",
        "vi": "Có {fail_rows_extract} hàng 'thất bại' có sẵn dưới dạng tệp CSV.",
        "ru": "В CSV-файле доступны строки {fail_rows_extract} 'fail'.",
        "cs": "K dispozici je {fail_rows_extract} 'neúspěšných' řádků jako soubor CSV.",
        "pl": "Istnieje {fail_rows_extract} wierszy 'fail' dostępnych jako plik CSV.",
        "da": "Der er {fail_rows_extract} 'fail' rækker tilgængelige som CSV fil.",
        "sv": "Det finns {fail_rows_extract} 'fail'-rader tillgängliga som CSV-fil.",
        "nb": "Det er {fail_rows_extract} 'mislykkede' rader tilgjengelig som CSV-fil.",
        "nl": "Er zijn {fail_rows_extract} 'fail' rijen beschikbaar als CSV-bestand.",
        "fi": "CSV-tiedostona on saatavilla {fail_rows_extract} 'epäonnistunutta' riviä.",
        "is": "Það eru {fail_rows_extract} 'misheppnaðar' raðir fáanlegar sem CSV-skrá.",
        "ar": "هناك {fail_rows_extract} صفوف 'فاشلة' متاحة كملف CSV.",
        "hi": "CSV फ़ाइल के रूप में {fail_rows_extract} 'असफल' पंक्तियां उपलब्ध हैं।",
        "el": "Υπάρχουν {fail_rows_extract} 'αποτυχημένες' γραμμές διαθέσιμες ως αρχείο CSV.",
    },
    "report_no_table_preconditions": {
        "en": "No modifications of the table.",
        "fr": "Aucune modification du tableau.",
        "de": "Keine Änderungen der Tabelle.",
        "it": "Nessuna alterazione della tabella.",
        "es": "Sin alteraciones de la tabla.",
        "pt": "Sem alterações da tabela.",
        "ro": "Nicio modificare a tabelului.",
        "tr": "Tabloda değişiklik yok.",
        "zh-Hans": "数据表无变化。",
        "zh-Hant": "資料表未經修改。",
        "ja": "テーブルの変更はありません。",
        "ko": "테이블 수정 없음.",
        "vi": "Không có chỉnh sửa nào đối với bảng.",
        "ru": "Никаких изменений таблицы данных.",
        "cs": "Žádné úpravy tabulky.",
        "pl": "Brak zmian w tabeli.",
        "da": "Ingen modifikationer af tabellen.",
        "sv": "Inga ändringar i tabellen.",
        "nb": "Ingen endringer av tabellen.",
        "nl": "Geen wijzigingen aan de tafel.",
        "fi": "Ei muutoksia taulukkoon.",
        "is": "Engar breytingar á töflunni.",
        "ar": "لا تعديلات على الجدول.",
        "hi": "तालिका में कोई परिवर्तन नहीं।",
        "el": "Καμία τροποποίηση του πίνακα.",
    },
    "report_some_table_preconditions": {
        "en": "The data table was modified for this step.",
        "fr": "Le tableau a été modifié pour cette étape.",
        "de": "Die Tabelle wurde für diesen Schritt geändert.",
        "it": "La tabella è stata modificata per questo passaggio.",
        "es": "La tabla se modificó para este paso.",
        "pt": "A tabela foi modificada para esta etapa.",
        "ro": "Tabelul de date a fost modificat pentru acest pas.",
        "tr": "Veri tablosu bu adım için değiştirildi.",
        "zh-Hans": "数据表已为此步骤修改。",
        "zh-Hant": "已為此步驟修改資料表。",
        "ja": "このステップのためにデータテーブルが変更されました。",
        "ko": "이 단계에서 데이터 테이블이 수정되었습니다.",
        "vi": "Bảng dữ liệu đã được chỉnh sửa cho bước này.",
        "ru": "Таблица данных была изменена для этого шага.",
        "cs": "Datová tabulka byla pro tento krok upravena.",
        "pl": "Tabela została zmieniona w tym kroku.",
        "da": "Data tabellen blev modificeret for dette trin.",
        "sv": "Datatabellen modifierades för detta steg.",
        "nb": "Datatabellen ble endret for dette trinnet.",
        "nl": "De tafel is voor deze stap gewijzigd.",
        "fi": "Taulukkoa muokattiin tätä vaihetta varten.",
        "is": "Gagnataflan var breytt fyrir þetta skref.",
        "ar": "تم تعديل جدول البيانات لهذه الخطوة.",
        "hi": "इस चरण के लिए डेटा तालिका को संशोधित किया गया था।",
        "el": "Ο πίνακας δεδομένων τροποποιήθηκε για αυτό το βήμα.",
    },
    "report_on_segmentation": {
        "en": "Using segment associated with value '{seg_val_x}' from column '{seg_col_x}'.",
        "fr": "Utilisation du segment associé à la valeur '{seg_val_x}' de la colonne '{seg_col_x}'.",
        "de": "Unter Verwendung des Segments mit dem Wert assoziiert‚ '{seg_val_x}‘ von Spalte '{seg_col_x}'.",
        "it": "Utilizzo del segmento associato al valore '{seg_val_x}' dalla colonna '{seg_col_x}'.",
        "es": "Usando el segmento asociado con el valor '{seg_val_x}' de la columna '{seg_col_x}'.",
        "pt": "Usando o segmento associado ao valor '{seg_val_x}' da coluna '{seg_col_x}'.",
        "ro": "Utilizând segmentul asociat cu valoarea '{seg_val_x}' din coloana '{seg_col_x}'.",
        "tr": "'{seg_col_x}' sütunundaki '{seg_val_x}' değeriyle ilişkili segment kullanılıyor.",
        "zh-Hans": "使用与列'{seg_col_x}'中的值'{seg_val_x}'关联的细分。",
        "zh-Hant": "使用與「{seg_col_x}」欄位中「{seg_val_x}」值關聯的區段。",
        "ja": "列'{seg_col_x}'の値'{seg_val_x}'に関連するセグメントを使用しています。",
        "ko": "열 '{seg_col_x}'의 값 '{seg_val_x}'와 연관된 세그먼트 사용 중.",
        "vi": "Sử dụng phân đoạn liên quan đến giá trị '{seg_val_x}' từ cột '{seg_col_x}'.",
        "ru": "Использование сегмента, связанного со значением '{seg_val_x}' из столбца '{seg_col_x}'.",
        "cs": "Používá se segment spojený s hodnotou '{seg_val_x}' ze sloupce '{seg_col_x}'.",
        "pl": "Korzystanie z segmentu zwiazanego z wartościa '{seg_val_x}' z kolumny '{seg_col_x}'.",
        "da": "Brug af det segment, der er knyttet til værdien '{seg_val_x}' fra kolonnen '{seg_col_x}'.",
        "sv": "Med hjälp av det segment som är associerat med värdet '{seg_val_x}' från kolumnen '{seg_col_x}'.",
        "nb": "Bruker segment knyttet til verdien '{seg_val_x}' fra kolonnen '{seg_col_x}'.",
        "nl": "Het segment gebruiken dat is gekoppeld aan de waarde '{seg_val_x}' uit kolom '{seg_col_x}'.",
        "fi": "Käytetään sarakkeeseen '{seg_col_x}' liittyvää arvon '{seg_val_x}' segmenttiä.",
        "is": "Notar hluta tengt við gildið '{seg_val_x}' úr dálki '{seg_col_x}'.",
        "ar": "استخدام القطاع المرتبط بالقيمة '{seg_val_x}' من العمود '{seg_col_x}'.",
        "hi": "स्तंभ '{seg_col_x}' से मूल्य '{seg_val_x}' से जुड़े खंड का उपयोग कर रहा है।",
        "el": "Χρησιμοποιείται τμήμα που σχετίζεται με την τιμή '{seg_val_x}' από τη στήλη '{seg_col_x}'.",
    },
    "report_no_evaluation_issues": {
        "en": "No evaluation issues.",
        "fr": "Aucun problème d'évaluation.",
        "de": "Keine Bewertungsprobleme.",
        "it": "Nessun problema di valutazione.",
        "es": "Sin problemas de evaluación.",
        "pt": "Sem problemas de avaliação.",
        "ro": "Nicio problemă de evaluare.",
        "tr": "Değerlendirme sorunu yok.",
        "zh-Hans": "没有评估问题。",
        "zh-Hant": "沒有評估問題。",
        "ja": "評価の問題はありません。",
        "ko": "평가 문제 없음.",
        "vi": "Không có vấn đề đánh giá.",
        "ru": "Нет проблем с оценкой.",
        "cs": "Žádné problémy s vyhodnocením.",
        "pl": "Brak problemów z ocena.",
        "da": "Ingen evalueringsproblemer.",
        "sv": "Inga utvärderingsproblem.",
        "nb": "Ingen evalueringsproblemer.",
        "nl": "Geen waarderingsproblemen.",
        "fi": "Ei arviointiongelmia.",
        "is": "Engin matsleg vandamál.",
        "ar": "لا توجد مشكلات تقييم.",
        "hi": "कोई मूल्यांकन समस्या नहीं।",
        "el": "Κανένα πρόβλημα αξιολόγησης.",
    },
    "report_col_step": {
        "en": "STEP",
        "fr": "ÉTAPE",
        "de": "SCHRITT",
        "it": "INDICE",
        "es": "PASO",
        "pt": "PASSO",
        "ro": "PAS",
        "tr": "ADIM",
        "zh-Hans": "步（STEP）",
        "zh-Hant": "步驟（STEP）",
        "ja": "ステップ",
        "ko": "단계",
        "vi": "BƯỚC",
        "ru": "ШАГ",
        "cs": "KROK",
        "pl": "KROK",
        "da": "TRIN",
        "sv": "STEG",
        "nb": "TRINN",
        "nl": "STAP",
        "fi": "VAIHE",
        "is": "SKREF",
        "ar": "خطوة",
        "hi": "चरण",
        "el": "ΒΗΜΑ",
    },
    "report_col_steps": {
        "en": "STEPS",
        "fr": "ÉTAPES",
        "de": "SCHRITTE",
        "it": "INDICI",
        "es": "PASOS",
        "pt": "PASSOS",
        "ro": "PAȘI",
        "tr": "ADIMLAR",
        "zh-Hans": "步（STEPS）",
        "zh-Hant": "步驟（STEPS）",
        "ja": "ステップ",
        "ko": "단계",
        "vi": "CÁC BƯỚC",
        "ru": "ШАГИ",
        "cs": "KROKY",
        "pl": "KROKI",
        "da": "TRIN",
        "sv": "STEG",
        "nb": "TRINN",
        "nl": "STAPPEN",
        "fi": "VAIHEET",
        "is": "SKREF",
        "ar": "خطوات",
        "hi": "चरण",
        "el": "ΒΗΜΑΤΑ",
    },
    "report_col_columns": {
        "en": "COLUMNS",
        "fr": "COLONNES",
        "de": "SPALTEN",
        "it": "COLONNE",
        "es": "COLUMNAS",
        "pt": "COLUNAS",
        "ro": "COLOANE",
        "tr": "SÜTUNLARI",
        "zh-Hans": "列",
        "zh-Hant": "欄位",
        "ja": "列",
        "ko": "열",
        "vi": "CÁC CỘT",
        "ru": "КОЛУМЫ",
        "cs": "SLOUPCE",
        "pl": "KOLUMNY",
        "da": "KOLONNER",
        "sv": "KOLONNER",
        "nb": "KOLONNER",
        "nl": "KOLOMMEN",
        "fi": "SARAKKEET",
        "is": "DÁLKAR",
        "ar": "أعمدة",
        "hi": "स्तंभ",
        "el": "ΣΤΗΛΕΣ",
    },
    "report_col_values": {
        "en": "VALUES",
        "fr": "VALEURS",
        "de": "WERTE",
        "it": "VALORI",
        "es": "VALORES",
        "pt": "VALORES",
        "ro": "VALORI",
        "tr": "DEĞERLER",
        "zh-Hans": "值",
        "zh-Hant": "數值",
        "ja": "値",
        "ko": "값",
        "vi": "GIÁ TRỊ",
        "ru": "ЦЕННОСТИ",
        "cs": "HODNOTY",
        "pl": "WARTOŚCI",
        "da": "VÆRDIER",
        "sv": "VÄRDEN",
        "nb": "VERDIER",
        "nl": "WAARDEN",
        "fi": "ARVOT",
        "is": "GILDI",
        "ar": "قيم",
        "hi": "मान",
        "el": "ΤΙΜΕΣ",
    },
    "report_col_units": {
        "en": "UNITS",
        "fr": "UNITÉ",
        "de": "EINH.",
        "it": "UNITÀ",
        "es": "UNID.",
        "pt": "UNID.",
        "ro": "UNIT.",
        "tr": "BİRİM",
        "zh-Hans": "单元",
        "zh-Hant": "單元",
        "ja": "単位",
        "ko": "단위",
        "vi": "ĐV",
        "ru": "ЕД.",
        "cs": "JEDN.",
        "pl": "JEDN.",
        "da": "ENH.",
        "sv": "ENH.",
        "nb": "ENH.",
        "nl": "EENH.",
        "fi": "YKS.",
        "is": "EINH.",
        "ar": "وحدات",
        "hi": "इकाइयाँ",
        "el": "ΜΟΝ.",
    },
    "report_col_pass": {
        "en": "PASS",
        "fr": "RÉUS",
        "de": "OK",
        "it": "PASS",
        "es": "PASA",
        "pt": "PASS",
        "ro": "TRECE",
        "tr": "GEÇ",
        "zh-Hans": "通过",
        "zh-Hant": "通過",
        "ja": "合格",
        "ko": "통과",
        "vi": "ĐẠT",
        "ru": "ПРОШ",
        "cs": "PROŠL",
        "pl": "ZDANE",
        "da": "OK",
        "sv": "OK",
        "nb": "OK",
        "nl": "OK",
        "fi": "LÄP.",
        "is": "STAÐ.",
        "ar": "ناجح",
        "hi": "सफल",
        "el": "ΕΠΙΤ.",
    },
    "report_col_fail": {
        "en": "FAIL",
        "fr": "ÉCHEC",
        "de": "FEHL.",
        "it": "FALL.",
        "es": "FALLO",
        "pt": "FALHA",
        "ro": "EȘEC",
        "tr": "BAŞRZ",
        "zh-Hans": "失败",
        "zh-Hant": "失敗",
        "ja": "不合格",
        "ko": "실패",
        "vi": "LỖI",
        "ru": "СБОЙ",
        "cs": "SELH.",
        "pl": "BŁĄD",
        "da": "FEJL",
        "sv": "FEL",
        "nb": "FEIL",
        "nl": "FOUT",
        "fi": "EI LÄP.",
        "is": "FALL.",
        "ar": "فشل",
        "hi": "असफल",
        "el": "ΑΠΟΤ.",
    },
    "report_column_schema": {
        "en": "SCHEMA",
        "fr": "SCHÉMA",
        "de": "SCHEMA",
        "it": "SCHEMA",
        "es": "ESQUEMA",
        "pt": "ESQUEMA",
        "ro": "SCHEMĂ",
        "tr": "ŞEMA",
        "zh-Hans": "模式（SCHEMA）",
        "zh-Hant": "綱要（SCHEMA）",
        "ja": "スキーマ",
        "ko": "스키마",
        "vi": "LƯỢC ĐỒ",
        "ru": "СХЕМА",
        "cs": "SCHÉMA",
        "pl": "SCHEMAT",
        "da": "SCHEMA",
        "sv": "SCHEMA",
        "nb": "SKJEMA",
        "nl": "REGELING",
        "fi": "SKEEMA",
        "is": "SKEMA",
        "ar": "مخطط",
        "hi": "स्कीमा",
        "el": "ΣΧΗΜΑ",
    },
    "report_r_col_types": {
        "en": "Python TYPES",
        "fr": "TYPES Python",
        "de": "Python-TYPEN",
        "it": "TIPI Python",
        "es": "TIPOS Python",
        "pt": "TIPOS Python",
        "ro": "TIPURI Python",
        "tr": "Python TÜRLERİ",
        "zh-Hans": "Python类型",
        "zh-Hant": "Python類型",
        "ja": "Python型",
        "ko": "Python 타입",
        "vi": "KIỂU Python",
        "ru": "Python ТИПЫ",
        "cs": "Python TYPY",
        "pl": "TYPY Python",
        "da": "Python TYPER",
        "sv": "Python TYPER",
        "nb": "Python TYPER",
        "nl": "Python-TYPEN",
        "fi": "Python-TYYPIT",
        "is": "Python TEGUNDIR",
        "ar": "أنواع بايثون",
        "hi": "Python प्रकार",
        "el": "ΤΥΠΟΙ Python",
    },
    "report_r_sql_types": {
        "en": "SQL TYPES",
        "fr": "TYPES SQL",
        "de": "SQL-TYPEN",
        "it": "TIPI SQL",
        "es": "TIPOS SQL",
        "pt": "TIPOS SQL",
        "ro": "TIPURI SQL",
        "tr": "SQL TÜRLERİ",
        "zh-Hans": "SQL类型",
        "zh-Hant": "SQL類型",
        "ja": "SQL型",
        "ko": "SQL 타입",
        "vi": "KIỂU SQL",
        "ru": "ВИДЫ SQL",
        "cs": "SQL TYPY",
        "pl": "TYPY SQL",
        "da": "SQL TYPER",
        "sv": "SQL TYPER",
        "nb": "SQL TYPER",
        "nl": "SQL-TYPEN",
        "fi": "SQL-TYYPIT",
        "is": "SQL TEGUNDIR",
        "ar": "أنواع SQL",
        "hi": "SQL प्रकार",
        "el": "ΤΥΠΟΙ SQL",
    },
}


STEP_REPORT_TEXT = {
    "column_matches_regex": {
        "en": "{column} matches regex {values}",
        "fr": "{column} correspond à l'expression régulière {values}",
        "de": "{column} stimmt mit regulärem Ausdruck {values} überein",
        "it": "{column} corrisponde all'espressione regolare {values}",
        "es": "{column} coincide con la expresión regular {values}",
        "pt": "{column} corresponde à expressão regular {values}",
        "ro": "{column} se potrivește cu expresia regulată {values}",
        "tr": "{column} düzenli ifade {values} ile eşleşiyor",
        "zh-Hans": "{column} 匹配正则表达式 {values}",
        "zh-Hant": "{column} 匹配正則表達式 {values}",
        "ja": "{column} が正規表現 {values} に一致",
        "ko": "{column}이(가) 정규식 {values}와(과) 일치",
        "vi": "{column} khớp với biểu thức chính quy {values}",
        "ru": "{column} соответствует регулярному выражению {values}",
        "cs": "{column} odpovídá regulárnímu výrazu {values}",
        "pl": "{column} pasuje do wyrażenia regularnego {values}",
        "da": "{column} matcher regulært udtryk {values}",
        "sv": "{column} matchar reguljärt uttryck {values}",
        "nb": "{column} samsvarer med regulæruttrykk {values}",
        "nl": "{column} komt overeen met reguliere expressie {values}",
        "fi": "{column} vastaa säännöllistä lauseketta {values}",
        "is": "{column} passar við reglulega segðina {values}",
        "ar": "{column} يتطابق مع التعبير المنتظم {values}",
        "hi": "{column} नियमित अभिव्यक्ति {values} से मेल खाता है",
        "el": "{column} ταιριάζει με την κανονική έκφραση {values}",
    },
    "column_is_null": {
        "en": "{column} is Null",
        "fr": "{column} est Null",
        "de": "{column} ist Null",
        "it": "{column} è Null",
        "es": "{column} es Null",
        "pt": "{column} é Null",
        "ro": "{column} este Null",
        "tr": "{column} Null değerine sahip",
        "zh-Hans": "{column} 为 Null",
        "zh-Hant": "{column} 為 Null",
        "ja": "{column} は Null",
        "ko": "{column}이(가) Null임",
        "vi": "{column} là Null",
        "ru": "{column} равно Null",
        "cs": "{column} je Null",
        "pl": "{column} jest Null",
        "da": "{column} er Null",
        "sv": "{column} är Null",
        "nb": "{column} er Null",
        "nl": "{column} is Null",
        "fi": "{column} on Null",
        "is": "{column} er Null",
        "ar": "{column} خالي",
        "hi": "{column} Null है",
        "el": "{column} είναι Null",
    },
    "column_is_not_null": {
        "en": "{column} is Not Null",
        "fr": "{column} n'est pas Null",
        "de": "{column} ist nicht Null",
        "it": "{column} non è Null",
        "es": "{column} no es Null",
        "pt": "{column} não é Null",
        "ro": "{column} nu este Null",
        "tr": "{column} Null değerine sahip değil",
        "zh-Hans": "{column} 不为 Null",
        "zh-Hant": "{column} 不為 Null",
        "ja": "{column} は Null ではない",
        "ko": "{column}이(가) Null이 아님",
        "vi": "{column} không phải Null",
        "ru": "{column} не равно Null",
        "cs": "{column} není Null",
        "pl": "{column} nie jest Null",
        "da": "{column} er ikke Null",
        "sv": "{column} är inte Null",
        "nb": "{column} er ikke Null",
        "nl": "{column} is niet Null",
        "fi": "{column} ei ole Null",
        "is": "{column} er ekki Null",
        "ar": "{column} غير خالي",
        "hi": "{column} Null नहीं है",
        "el": "{column} δεν είναι Null",
    },
    "rows_distinct_all": {
        "en": "All rows are distinct",
        "fr": "Toutes les lignes sont distinctes",
        "de": "Alle Zeilen sind eindeutig",
        "it": "Tutte le righe sono distinte",
        "es": "Todas las filas son distintas",
        "pt": "Todas as linhas são distintas",
        "ro": "Toate rândurile sunt distincte",
        "tr": "Tüm satırlar benzersizdir",
        "zh-Hans": "所有行都是不同的",
        "zh-Hant": "所有行都是不同的",
        "ja": "すべての行が一意です",
        "ko": "모든 행이 고유합니다",
        "vi": "Tất cả các hàng đều khác nhau",
        "ru": "Все строки уникальны",
        "cs": "Všechny řádky jsou jedinečné",
        "pl": "Wszystkie wiersze są unikalne",
        "da": "Alle rækker er unikke",
        "sv": "Alla rader är distinkta",
        "nb": "Alle rader er unike",
        "nl": "Alle rijen zijn uniek",
        "fi": "Kaikki rivit ovat erillisiä",
        "is": "Allar raðir eru einstakar",
        "ar": "جميع الصفوف متميزة",
        "hi": "सभी पंक्तियां अलग-अलग हैं",
        "el": "Όλες οι γραμμές είναι διακριτές",
    },
    "rows_distinct_subset": {
        "en": "Rows are distinct across a subset of columns",
        "fr": "Les lignes sont distinctes sur un sous-ensemble de colonnes",
        "de": "Zeilen sind in einer Teilmenge von Spalten eindeutig",
        "it": "Le righe sono distinte in un sottoinsieme di colonne",
        "es": "Las filas son distintas en un subconjunto de columnas",
        "pt": "As linhas são distintas em um subconjunto de colunas",
        "ro": "Rândurile sunt distincte într-un subset de coloane",
        "tr": "Satırlar, sütunların bir alt kümesinde benzersizdir",
        "zh-Hans": "行在列的子集中是不同的",
        "zh-Hant": "行在列的子集中是不同的",
        "ja": "行は列のサブセット間で一意です",
        "ko": "행이 열의 하위 집합에서 고유합니다",
        "vi": "Các hàng là khác biệt trong một tập con của các cột",
        "ru": "Строки уникальны в подмножестве столбцов",
        "cs": "Řádky jsou jedinečné napříč podmnožinou sloupců",
        "pl": "Wiersze są unikalne w podzbiorze kolumn",
        "da": "Rækker er unikke på tværs af en delmængde af kolonner",
        "sv": "Rader är distinkta över en delmängd av kolumner",
        "nb": "Rader er unike på tvers av en delmengde av kolonner",
        "nl": "Rijen zijn uniek over een subset van kolommen",
        "fi": "Rivit ovat erillisiä sarakkeiden osajoukossa",
        "is": "Raðir eru einstakar í undirsafni dálka",
        "ar": "الصفوف متميزة عبر مجموعة فرعية من الأعمدة",
        "hi": "पंक्तियां स्तंभों के एक उपसमूह में अलग-अलग हैं",
        "el": "Οι γραμμές είναι διακριτές σε ένα υποσύνολο στηλών",
    },
    "rows_complete_all": {
        "en": "All rows are complete",
        "fr": "Toutes les lignes sont complètes",
        "de": "Alle Zeilen sind vollständig",
        "it": "Tutte le righe sono complete",
        "es": "Todas las filas están completas",
        "pt": "Todas as linhas estão completas",
        "ro": "Toate rândurile sunt complete",
        "tr": "Tüm satırlar eksiksizdir",
        "zh-Hans": "所有行都是完整的",
        "zh-Hant": "所有行都是完整的",
        "ja": "すべての行が完全です",
        "ko": "모든 행이 완전합니다",
        "vi": "Tất cả các hàng đều đầy đủ",
        "ru": "Все строки заполнены полностью",
        "cs": "Všechny řádky jsou úplné",
        "pl": "Wszystkie wiersze są kompletne",
        "da": "Alle rækker er komplette",
        "sv": "Alla rader är kompletta",
        "nb": "Alle rader er komplette",
        "nl": "Alle rijen zijn compleet",
        "fi": "Kaikki rivit ovat täydellisiä",
        "is": "Allar raðir eru heildstæðar",
        "ar": "جميع الصفوف مكتملة",
        "hi": "सभी पंक्तियां पूर्ण हैं",
        "el": "Όλες οι γραμμές είναι πλήρεις",
    },
    "rows_complete_subset": {
        "en": "Rows are complete across a subset of columns",
        "fr": "Les lignes sont complètes sur un sous-ensemble de colonnes",
        "de": "Zeilen sind in einer Teilmenge von Spalten vollständig",
        "it": "Le righe sono complete in un sottoinsieme di colonne",
        "es": "Las filas están completas en un subconjunto de columnas",
        "pt": "As linhas estão completas em um subconjunto de colunas",
        "ro": "Rândurile sunt complete într-un subset de coloane",
        "tr": "Satırlar, sütunların bir alt kümesinde eksiksizdir",
        "zh-Hans": "行在列的子集中是完整的",
        "zh-Hant": "行在列的子集中是完整的",
        "ja": "行は列のサブセット間で完全です",
        "ko": "행이 열의 하위 집합에서 완전합니다",
        "vi": "Các hàng đầy đủ trong một tập con của các cột",
        "ru": "Строки полностью заполнены в подмножестве столбцов",
        "cs": "Řádky jsou úplné napříč podmnožinou sloupců",
        "pl": "Wiersze są kompletne w podzbiorze kolumn",
        "da": "Rækker er komplette på tværs af en delmængde af kolonner",
        "sv": "Rader är kompletta över en delmängd av kolumner",
        "nb": "Rader er komplette på tvers av en delmengde av kolonner",
        "nl": "Rijen zijn compleet over een subset van kolommen",
        "fi": "Rivit ovat täydellisiä sarakkeiden osajoukossa",
        "is": "Raðir eru heildstæðar í undirsafni dálka",
        "ar": "الصفوف مكتملة عبر مجموعة فرعية من الأعمدة",
        "hi": "पंक्तियां स्तंभों के एक उपसमूह में पूर्ण हैं",
        "el": "Οι γραμμές είναι πλήρεις σε ένα υποσύνολο στηλών",
    },
    "report_for_step_i": {
        "en": "Report for Validation Step {i}",
        "fr": "Rapport pour l'étape de validation {i}",
        "de": "Bericht für Validierungsschritt {i}",
        "it": "Rapporto per la fase di convalida {i}",
        "es": "Informe para el paso de validación {i}",
        "pt": "Relatório para a etapa de validação {i}",
        "ro": "Raport pentru pasul de validare {i}",
        "tr": "Doğrulama Adımı {i} için Rapor",
        "zh-Hans": "验证步骤 {i} 的报告",
        "zh-Hant": "驗證步驟 {i} 的報告",
        "ja": "検証ステップ {i} のレポート",
        "ko": "검증 단계 {i}에 대한 보고서",
        "vi": "Báo cáo cho bước kiểm định {i}",
        "ru": "Отчет для шага проверки {i}",
        "cs": "Zpráva pro validační krok {i}",
        "pl": "Raport dla kroku walidacji {i}",
        "da": "Rapport for valideringstrin {i}",
        "sv": "Rapport för valideringssteg {i}",
        "nb": "Rapport for valideringstrinn {i}",
        "nl": "Rapport voor validatiestap {i}",
        "fi": "Raportti validointivaiheelle {i}",
        "is": "Skýrsla fyrir gildisstaðfestingarskref {i}",
        "ar": "تقرير لخطوة التحقق {i}",
        "hi": "सत्यापन चरण {i} के लिए रिपोर्ट",
        "el": "Αναφορά για το βήμα επικύρωσης {i}",
    },
    "assertion_header_text": {
        "en": "ASSERTION",
        "fr": "ASSERTION",
        "de": "BEHAUPTUNG",
        "it": "ASSERZIONE",
        "es": "ASERCIÓN",
        "pt": "ASSERÇÃO",
        "ro": "AFIRMAȚIE",
        "tr": "İDDİA",
        "zh-Hans": "断言",
        "zh-Hant": "斷言",
        "ja": "アサーション",
        "ko": "어설션",
        "vi": "KHẲNG ĐỊNH",
        "ru": "УТВЕРЖДЕНИЕ",
        "cs": "TVRZENÍ",
        "pl": "ASERCJA",
        "da": "PÅSTAND",
        "sv": "PÅSTÅENDE",
        "nb": "PÅSTAND",
        "nl": "BEWERING",
        "fi": "VÄITTÄMÄ",
        "is": "STAÐHÆFING",
        "ar": "تأكيد",
        "hi": "कथन",
        "el": "ΙΣΧΥΡΙΣΜΟΣ",
    },
    "failure_rate_summary": {
        "en": "{failure_rate} TEST UNIT FAILURES IN COLUMN <strong>{column_position}</strong>",
        "fr": "{failure_rate} ÉCHECS D'UNITÉS DE TEST DANS LA COLONNE <strong>{column_position}</strong>",
        "de": "{failure_rate} TESTEINHEITENFEHLER IN SPALTE <strong>{column_position}</strong>",
        "it": "{failure_rate} FALLIMENTI DI UNITÀ DI TEST NELLA COLONNA <strong>{column_position}</strong>",
        "es": "{failure_rate} FALLOS DE UNIDAD DE PRUEBA EN LA COLUMNA <strong>{column_position}</strong>",
        "pt": "{failure_rate} FALHAS DE UNIDADE DE TESTE NA COLUNA <strong>{column_position}</strong>",
        "ro": "{failure_rate} EȘECURI ALE UNITĂȚILOR DE TEST ÎN COLOANA <strong>{column_position}</strong>",
        "tr": "{failure_rate} <strong>{column_position}</strong> SÜTUNUNDA TEST BİRİMİ HATALARI",
        "zh-Hans": "列 <strong>{column_position}</strong> 中有 {failure_rate} 个测试单元失败",
        "zh-Hant": "欄位 <strong>{column_position}</strong> 中有 {failure_rate} 個測試單元失敗",
        "ja": "列 <strong>{column_position}</strong> で {failure_rate} テストユニットの失敗",
        "ko": "<strong>{column_position}</strong> 열에서 {failure_rate} 테스트 단위 실패",
        "vi": "{failure_rate} LỖI ĐƠN VỊ KIỂM TRA TRONG CỘT <strong>{column_position}</strong>",
        "ru": "{failure_rate} СБОЕВ ТЕСТОВЫХ ЕДИНИЦ В СТОЛБЦЕ <strong>{column_position}</strong>",
        "cs": "{failure_rate} SELHÁNÍ TESTOVACÍCH JEDNOTEK VE SLOUPCI <strong>{column_position}</strong>",
        "pl": "{failure_rate} NIEPOWODZEŃ JEDNOSTEK TESTOWYCH W KOLUMNIE <strong>{column_position}</strong>",
        "da": "{failure_rate} TEST ENHED FEJL I KOLONNE <strong>{column_position}</strong>",
        "sv": "{failure_rate} TESTENHETSFEL I KOLUMN <strong>{column_position}</strong>",
        "nb": "{failure_rate} TESTENHETSFEIL I KOLONNE <strong>{column_position}</strong>",
        "nl": "{failure_rate} TESTEENHEID FOUTEN IN KOLOM <strong>{column_position}</strong>",
        "fi": "{failure_rate} TESTIYKSIKÖN VIRHEITÄ SARAKKEESSA <strong>{column_position}</strong>",
        "is": "{failure_rate} PRÓFUNAREININGAR VILLUR Í DÁLKI <strong>{column_position}</strong>",
        "ar": "{failure_rate} فشل وحدات الاختبار في العمود <strong>{column_position}</strong>",
        "hi": "कॉलम <strong>{column_position}</strong> में {failure_rate} परीक्षण इकाई विफलताएँ",
        "el": "{failure_rate} ΑΠΟΤΥΧΙΕΣ ΜΟΝΑΔΩΝ ΔΟΚΙΜΗΣ ΣΤΗ ΣΤΗΛΗ <strong>{column_position}</strong>",
    },
    "not_shown": {
        "en": "(NOT SHOWN)",
        "fr": "(NON AFFICHÉ)",
        "de": "(NICHT ANGEZEIGT)",
        "it": "(NON MOSTRATO)",
        "es": "(NO MOSTRADO)",
        "pt": "(NÃO MOSTRADO)",
        "ro": "(NEAFIȘAT)",
        "tr": "(GÖSTERİLMİYOR)",
        "zh-Hans": "(未显示)",
        "zh-Hant": "(未顯示)",
        "ja": "(表示されていません)",
        "ko": "(표시되지 않음)",
        "vi": "(KHÔNG HIỂN THỊ)",
        "ru": "(НЕ ПОКАЗАНО)",
        "cs": "(NEZOBRAZENO)",
        "pl": "(NIE POKAZANO)",
        "da": "(IKKE VIST)",
        "sv": "(VISAS INTE)",
        "nb": "(IKKE VIST)",
        "nl": "(NIET GETOOND)",
        "fi": "(EI NÄYTETTY)",
        "is": "(EKKI SÝNT)",
        "ar": "(غير معروض)",
        "hi": "(नहीं दिखाया गया)",
        "el": "(ΔΕΝ ΕΜΦΑΝΙΖΕΤΑΙ)",
    },
    "extract_text_first": {
        "en": "<div>EXTRACT OF FIRST <strong>{extract_length_resolved}</strong> ROWS {shown_failures}:</div>",
        "fr": "<div>EXTRAIT DES PREMIÈRES <strong>{extract_length_resolved}</strong> LIGNES {shown_failures}:</div>",
        "de": "<div>AUSZUG DER ERSTEN <strong>{extract_length_resolved}</strong> ZEILEN {shown_failures}:</div>",
        "it": "<div>ESTRATTO DELLE PRIME <strong>{extract_length_resolved}</strong> RIGHE {shown_failures}:</div>",
        "es": "<div>EXTRACTO DE LAS PRIMERAS <strong>{extract_length_resolved}</strong> FILAS {shown_failures}:</div>",
        "pt": "<div>EXTRATO DAS PRIMEIRAS <strong>{extract_length_resolved}</strong> LINHAS {shown_failures}:</div>",
        "ro": "<div>EXTRAS DIN PRIMELE <strong>{extract_length_resolved}</strong> RÂNDURI {shown_failures}:</div>",
        "tr": "<div>İLK <strong>{extract_length_resolved}</strong> SATIRIN ÇIKARIMI {shown_failures}:</div>",
        "zh-Hans": "<div>前 <strong>{extract_length_resolved}</strong> 行提取数据 {shown_failures}：</div>",
        "zh-Hant": "<div>前 <strong>{extract_length_resolved}</strong> 行提取資料 {shown_failures}：</div>",
        "ja": "<div>最初の <strong>{extract_length_resolved}</strong> 行の抽出 {shown_failures}：</div>",
        "ko": "<div>첫 <strong>{extract_length_resolved}</strong>행 추출 {shown_failures}:</div>",
        "vi": "<div>TRÍCH XUẤT <strong>{extract_length_resolved}</strong> HÀNG ĐẦU TIÊN {shown_failures}:</div>",
        "ru": "<div>ВЫДЕРЖКА ПЕРВЫХ <strong>{extract_length_resolved}</strong> СТРОК {shown_failures}:</div>",
        "cs": "<div>VÝPIS PRVNÍCH <strong>{extract_length_resolved}</strong> ŘÁDKŮ {shown_failures}:</div>",
        "pl": "<div>WYCIĄG Z PIERWSZYCH <strong>{extract_length_resolved}</strong> WIERSZY {shown_failures}:</div>",
        "da": "<div>UDDRAG AF FØRSTE <strong>{extract_length_resolved}</strong> RÆKKER {shown_failures}:</div>",
        "sv": "<div>UTDRAG AV FÖRSTA <strong>{extract_length_resolved}</strong> RADERNA {shown_failures}:</div>",
        "nb": "<div>UTDRAG AV FØRSTE <strong>{extract_length_resolved}</strong> RADER {shown_failures}:</div>",
        "nl": "<div>EXTRACT VAN EERSTE <strong>{extract_length_resolved}</strong> RIJEN {shown_failures}:</div>",
        "fi": "<div>OTE ENSIMMÄISISTÄ <strong>{extract_length_resolved}</strong> RIVISTÄ {shown_failures}:</div>",
        "is": "<div>ÚTDRÁTTUR AF FYRSTU <strong>{extract_length_resolved}</strong> RÖÐUM {shown_failures}:</div>",
        "ar": "<div>مقتطف من أول <strong>{extract_length_resolved}</strong> صفوف {shown_failures}:</div>",
        "hi": "<div>पहली <strong>{extract_length_resolved}</strong> पंक्तियों का निष्कर्ष {shown_failures}:</div>",
        "el": "<div>ΕΞΑΓΩΓΗ ΤΩΝ ΠΡΩΤΩΝ <strong>{extract_length_resolved}</strong> ΓΡΑΜΜΩΝ {shown_failures}:</div>",
    },
    "extract_text_all": {
        "en": "<div>EXTRACT OF ALL <strong>{extract_length_resolved}</strong> ROWS {shown_failures}:</div>",
        "fr": "<div>EXTRAIT DE TOUTES LES <strong>{extract_length_resolved}</strong> LIGNES {shown_failures}:</div>",
        "de": "<div>AUSZUG ALLER <strong>{extract_length_resolved}</strong> ZEILEN {shown_failures}:</div>",
        "it": "<div>ESTRATTO DI TUTTE LE <strong>{extract_length_resolved}</strong> RIGHE {shown_failures}:</div>",
        "es": "<div>EXTRACTO DE TODAS LAS <strong>{extract_length_resolved}</strong> FILAS {shown_failures}:</div>",
        "pt": "<div>EXTRATO DE TODAS AS <strong>{extract_length_resolved}</strong> LINHAS {shown_failures}:</div>",
        "ro": "<div>EXTRAS DIN TOATE CELE <strong>{extract_length_resolved}</strong> RÂNDURI {shown_failures}:</div>",
        "tr": "<div>TÜM <strong>{extract_length_resolved}</strong> SATIRIN ÇIKARIMI {shown_failures}:</div>",
        "zh-Hans": "<div>所有 <strong>{extract_length_resolved}</strong> 行提取数据 {shown_failures}：</div>",
        "zh-Hant": "<div>所有 <strong>{extract_length_resolved}</strong> 行提取資料 {shown_failures}：</div>",
        "ja": "<div>すべての <strong>{extract_length_resolved}</strong> 行の抽出 {shown_failures}：</div>",
        "ko": "<div>모든 <strong>{extract_length_resolved}</strong>행 추출 {shown_failures}:</div>",
        "vi": "<div>TRÍCH XUẤT TẤT CẢ <strong>{extract_length_resolved}</strong> HÀNG {shown_failures}:</div>",
        "ru": "<div>ВЫДЕРЖКА ВСЕХ <strong>{extract_length_resolved}</strong> СТРОК {shown_failures}:</div>",
        "cs": "<div>VÝPIS VŠECH <strong>{extract_length_resolved}</strong> ŘÁDKŮ {shown_failures}:</div>",
        "pl": "<div>WYCIĄG ZE WSZYSTKICH <strong>{extract_length_resolved}</strong> WIERSZY {shown_failures}:</div>",
        "da": "<div>UDDRAG AF ALLE <strong>{extract_length_resolved}</strong> RÆKKER {shown_failures}:</div>",
        "sv": "<div>UTDRAG AV ALLA <strong>{extract_length_resolved}</strong> RADERNA {shown_failures}:</div>",
        "nb": "<div>UTDRAG AV ALLE <strong>{extract_length_resolved}</strong> RADER {shown_failures}:</div>",
        "nl": "<div>EXTRACT VAN ALLE <strong>{extract_length_resolved}</strong> RIJEN {shown_failures}:</div>",
        "fi": "<div>OTE KAIKISTA <strong>{extract_length_resolved}</strong> RIVISTÄ {shown_failures}:</div>",
        "is": "<div>ÚTDRÁTTUR AF ÖLLUM <strong>{extract_length_resolved}</strong> RÖÐUM {shown_failures}:</div>",
        "ar": "<div>مقتطف من جميع <strong>{extract_length_resolved}</strong> صفوف {shown_failures}:</div>",
        "hi": "<div>सभी <strong>{extract_length_resolved}</strong> पंक्तियों का निष्कर्ष {shown_failures}:</div>",
        "el": "<div>ΕΞΑΓΩΓΗ ΟΛΩΝ ΤΩΝ <strong>{extract_length_resolved}</strong> ΓΡΑΜΜΩΝ {shown_failures}:</div>",
    },
    "shown_failures": {
        "en": "(WITH <span style='color: #B22222;'>TEST UNIT FAILURES IN RED</span>)",
        "fr": "(AVEC <span style='color: #B22222;'>ÉCHECS D'UNITÉS DE TEST EN ROUGE</span>)",
        "de": "(MIT <span style='color: #B22222;'>TESTEINHEITENFEHLERN IN ROT</span>)",
        "it": "(CON <span style='color: #B22222;'>FALLIMENTI DI UNITÀ DI TEST IN ROSSO</span>)",
        "es": "(CON <span style='color: #B22222;'>FALLOS DE UNIDAD DE PRUEBA EN ROJO</span>)",
        "pt": "(COM <span style='color: #B22222;'>FALHAS DE UNIDADE DE TESTE EM VERMELHO</span>)",
        "ro": "(CU <span style='color: #B22222;'>EȘECURI ALE UNITĂȚILOR DE TEST ÎN ROȘU</span>)",
        "tr": "(<span style='color: #B22222;'>KIRMIZI RENKLİ</span> TEST BİRİMİ HATALARI İLE)",
        "zh-Hans": "(<span style='color: #B22222;'>测试单元失败以红色显示</span>)",
        "zh-Hant": "(<span style='color: #B22222;'>測試單元失敗以紅色顯示</span>)",
        "ja": "(<span style='color: #B22222;'>赤色で表示されるテスト失敗</span>)",
        "ko": "(<span style='color: #B22222;'>빨간색으로 표시된 테스트 단위 실패</span>)",
        "vi": "(VỚI <span style='color: #B22222;'>LỖI ĐƠN VỊ KIỂM TRA HIỂN THỊ MÀU ĐỎ</span>)",
        "ru": "(С <span style='color: #B22222;'>СБОЯМИ ТЕСТОВЫХ ЕДИНИЦ, ВЫДЕЛЕННЫМИ КРАСНЫМ</span>)",
        "cs": "(SE <span style='color: #B22222;'>SELHÁNÍMI TESTOVACÍCH JEDNOTEK ČERVENĚ</span>)",
        "pl": "(Z <span style='color: #B22222;'>NIEPOWODZENIAMI JEDNOSTEK TESTOWYCH NA CZERWONO</span>)",
        "da": "(MED <span style='color: #B22222;'>TEST ENHED FEJL I RØD</span>)",
        "sv": "(MED <span style='color: #B22222;'>TESTENHETSFEL I RÖTT</span>)",
        "nb": "(MED <span style='color: #B22222;'>TESTENHETSFEIL I RØDT</span>)",
        "nl": "(MET <span style='color: #B22222;'>TESTEENHEID FOUTEN IN ROOD</span>)",
        "fi": "(<span style='color: #B22222;'>PUNAISELLA MERKITYT</span> TESTIYKSIKÖN VIRHEET)",
        "is": "(MEÐ <span style='color: #B22222;'>PRÓFUNAREININGAR VILLUR Í RAUÐU</span>)",
        "ar": "(مع <span style='color: #B22222;'>فشل وحدات الاختبار باللون الأحمر</span>)",
        "hi": "(<span style='color: #B22222;'>लाल रंग में</span> परीक्षण इकाई विफलताओं के साथ)",
        "el": "(ΜΕ <span style='color: #B22222;'>ΑΠΟΤΥΧΙΕΣ ΜΟΝΑΔΩΝ ΔΟΚΙΜΗΣ ΜΕ ΚΟΚΚΙΝΟ</span>)",
    },
    "extract_text_first_rows_distinct": {
        "en": "<div>EXTRACT OF FIRST <strong>{extract_length_resolved}</strong> ROWS:</div>",
        "fr": "<div>EXTRAIT DES PREMIÈRES <strong>{extract_length_resolved}</strong> LIGNES:</div>",
        "de": "<div>AUSZUG DER ERSTEN <strong>{extract_length_resolved}</strong> ZEILEN:</div>",
        "it": "<div>ESTRATTO DELLE PRIME <strong>{extract_length_resolved}</strong> RIGHE:</div>",
        "es": "<div>EXTRACTO DE LAS PRIMERAS <strong>{extract_length_resolved}</strong> FILAS:</div>",
        "pt": "<div>EXTRATO DAS PRIMEIRAS <strong>{extract_length_resolved}</strong> LINHAS:</div>",
        "ro": "<div>EXTRAS DIN PRIMELE <strong>{extract_length_resolved}</strong> RÂNDURI:</div>",
        "tr": "<div>İLK <strong>{extract_length_resolved}</strong> SATIRIN ÇIKARIMI:</div>",
        "zh-Hans": "<div>前 <strong>{extract_length_resolved}</strong> 行提取数据：</div>",
        "zh-Hant": "<div>前 <strong>{extract_length_resolved}</strong> 行提取資料：</div>",
        "ja": "<div>最初の <strong>{extract_length_resolved}</strong> 行の抽出：</div>",
        "ko": "<div>첫 <strong>{extract_length_resolved}</strong>행 추출:</div>",
        "vi": "<div>TRÍCH XUẤT <strong>{extract_length_resolved}</strong> HÀNG ĐẦU TIÊN:</div>",
        "ru": "<div>ВЫДЕРЖКА ПЕРВЫХ <strong>{extract_length_resolved}</strong> СТРОК:</div>",
        "cs": "<div>VÝPIS PRVNÍCH <strong>{extract_length_resolved}</strong> ŘÁDKŮ:</div>",
        "pl": "<div>WYCIĄG Z PIERWSZYCH <strong>{extract_length_resolved}</strong> WIERSZY:</div>",
        "da": "<div>UDDRAG AF FØRSTE <strong>{extract_length_resolved}</strong> RÆKKER:</div>",
        "sv": "<div>UTDRAG AV FÖRSTA <strong>{extract_length_resolved}</strong> RADERNA:</div>",
        "nb": "<div>UTDRAG AV FØRSTE <strong>{extract_length_resolved}</strong> RADER:</div>",
        "nl": "<div>EXTRACT VAN EERSTE <strong>{extract_length_resolved}</strong> RIJEN:</div>",
        "fi": "<div>OTE ENSIMMÄISISTÄ <strong>{extract_length_resolved}</strong> RIVISTÄ:</div>",
        "is": "<div>ÚTDRÁTTUR AF FYRSTU <strong>{extract_length_resolved}</strong> RÖÐUM:</div>",
        "ar": "<div>مقتطف من أول <strong>{extract_length_resolved}</strong> صفوف:</div>",
        "hi": "<div>पहली <strong>{extract_length_resolved}</strong> पंक्तियों का निष्कर्ष:</div>",
        "el": "<div>ΕΞΑΓΩΓΗ ΤΩΝ ΠΡΩΤΩΝ <strong>{extract_length_resolved}</strong> ΓΡΑΜΜΩΝ:</div>",
    },
    "extract_text_all_rows_distinct": {
        "en": "<div>EXTRACT OF ALL <strong>{extract_length_resolved}</strong> ROWS:</div>",
        "fr": "<div>EXTRAIT DE TOUTES LES <strong>{extract_length_resolved}</strong> LIGNES:</div>",
        "de": "<div>AUSZUG ALLER <strong>{extract_length_resolved}</strong> ZEILEN:</div>",
        "it": "<div>ESTRATTO DI TUTTE LE <strong>{extract_length_resolved}</strong> RIGHE:</div>",
        "es": "<div>EXTRACTO DE TODAS LAS <strong>{extract_length_resolved}</strong> FILAS:</div>",
        "pt": "<div>EXTRATO DE TODAS AS <strong>{extract_length_resolved}</strong> LINHAS:</div>",
        "ro": "<div>EXTRAS DIN TOATE CELE <strong>{extract_length_resolved}</strong> RÂNDURI:</div>",
        "tr": "<div>TÜM <strong>{extract_length_resolved}</strong> SATIRIN ÇIKARIMI:</div>",
        "zh-Hans": "<div>所有 <strong>{extract_length_resolved}</strong> 行提取数据：</div>",
        "zh-Hant": "<div>所有 <strong>{extract_length_resolved}</strong> 行提取資料：</div>",
        "ja": "<div>すべての <strong>{extract_length_resolved}</strong> 行の抽出：</div>",
        "ko": "<div>모든 <strong>{extract_length_resolved}</strong>행 추출:</div>",
        "vi": "<div>TRÍCH XUẤT TẤT CẢ <strong>{extract_length_resolved}</strong> HÀNG:</div>",
        "ru": "<div>ВЫДЕРЖКА ВСЕХ <strong>{extract_length_resolved}</strong> СТРОК:</div>",
        "cs": "<div>VÝPIS VŠECH <strong>{extract_length_resolved}</strong> ŘÁDKŮ:</div>",
        "pl": "<div>WYCIĄG ZE WSZYSTKICH <strong>{extract_length_resolved}</strong> WIERSZY:</div>",
        "da": "<div>UDDRAG AF ALLE <strong>{extract_length_resolved}</strong> RÆKKER:</div>",
        "sv": "<div>UTDRAG AV ALLA <strong>{extract_length_resolved}</strong> RADERNA:</div>",
        "nb": "<div>UTDRAG AV ALLE <strong>{extract_length_resolved}</strong> RADER:</div>",
        "nl": "<div>EXTRACT VAN ALLE <strong>{extract_length_resolved}</strong> RIJEN:</div>",
        "fi": "<div>OTE KAIKISTA <strong>{extract_length_resolved}</strong> RIVISTÄ:</div>",
        "is": "<div>ÚTDRÁTTUR AF ÖLLUM <strong>{extract_length_resolved}</strong> RÖÐUM:</div>",
        "ar": "<div>مقتطف من جميع <strong>{extract_length_resolved}</strong> صفوف:</div>",
        "hi": "<div>सभी <strong>{extract_length_resolved}</strong> पंक्तियों का निष्कर्ष:</div>",
        "el": "<div>ΕΞΑΓΩΓΗ ΟΛΩΝ ΤΩΝ <strong>{extract_length_resolved}</strong> ΓΡΑΜΜΩΝ:</div>",
    },
    "failure_rate_summary_rows_distinct": {
        "en": "{failure_rate} TEST UNIT FAILURES",
        "fr": "{failure_rate} ÉCHECS D'UNITÉS DE TEST",
        "de": "{failure_rate} TESTEINHEITENFEHLER",
        "it": "{failure_rate} FALLIMENTI DI UNITÀ DI TEST",
        "es": "{failure_rate} FALLOS DE UNIDAD DE PRUEBA",
        "pt": "{failure_rate} FALHAS DE UNIDADE DE TESTE",
        "ro": "{failure_rate} EȘECURI ALE UNITĂȚILOR DE TEST",
        "tr": "{failure_rate} TEST BİRİMİ HATALARI",
        "zh-Hans": "{failure_rate} 个测试单元失败",
        "zh-Hant": "{failure_rate} 個測試單元失敗",
        "ja": "{failure_rate} テストユニットの失敗",
        "ko": "{failure_rate} 테스트 단위 실패",
        "vi": "{failure_rate} LỖI ĐƠN VỊ KIỂM TRA",
        "ru": "{failure_rate} СБОЕВ ТЕСТОВЫХ ЕДИНИЦ",
        "cs": "{failure_rate} SELHÁNÍ TESTOVACÍCH JEDNOTEK",
        "pl": "{failure_rate} NIEPOWODZEŃ JEDNOSTEK TESTOWYCH",
        "da": "{failure_rate} TEST ENHED FEJL",
        "sv": "{failure_rate} TESTENHETSFEL",
        "nb": "{failure_rate} TESTENHETSFEIL",
        "nl": "{failure_rate} TESTEENHEID FOUTEN",
        "fi": "{failure_rate} TESTIYKSIKÖN VIRHEITÄ",
        "is": "{failure_rate} PRÓFUNAREININGAR VILLUR",
        "ar": "{failure_rate} فشل وحدات الاختبار",
        "hi": "{failure_rate} परीक्षण इकाई विफलताएँ",
        "el": "{failure_rate} ΑΠΟΤΥΧΙΕΣ ΜΟΝΑΔΩΝ ΔΟΚΙΜΗΣ",
    },
    "success_statement": {
        "en": "<strong>{n}</strong> TEST UNITS <em>ALL PASSED</em> IN COLUMN <strong>{column_position}</strong>",
        "fr": "<strong>{n}</strong> UNITÉS DE TEST <em>TOUTES RÉUSSIES</em> DANS LA COLONNE <strong>{column_position}</strong>",
        "de": "<strong>{n}</strong> TESTEINHEITEN <em>ALLE BESTANDEN</em> IN SPALTE <strong>{column_position}</strong>",
        "it": "<strong>{n}</strong> UNITÀ DI TEST <em>TUTTE SUPERATE</em> NELLA COLONNA <strong>{column_position}</strong>",
        "es": "<strong>{n}</strong> UNIDADES DE PRUEBA <em>TODAS APROBADAS</em> EN LA COLUMNA <strong>{column_position}</strong>",
        "pt": "<strong>{n}</strong> UNIDADES DE TESTE <em>TODAS APROVADAS</em> NA COLUNA <strong>{column_position}</strong>",
        "ro": "<strong>{n}</strong> UNITĂȚI DE TEST <em>TOATE TRECUTE</em> ÎN COLOANA <strong>{column_position}</strong>",
        "tr": "<strong>{column_position}</strong> SÜTUNUNDA <strong>{n}</strong> TEST BİRİMİNİN <em>TÜMÜ GEÇTİ</em>",
        "zh-Hans": "列 <strong>{column_position}</strong> 中的 <strong>{n}</strong> 个测试单元<em>全部通过</em>",
        "zh-Hant": "欄位 <strong>{column_position}</strong> 中的 <strong>{n}</strong> 個測試單元<em>全部通過</em>",
        "ja": "列 <strong>{column_position}</strong> で <strong>{n}</strong> のテストユニットが<em>すべて合格</em>",
        "ko": "<strong>{column_position}</strong> 열에서 <strong>{n}</strong> 테스트 단위 <em>모두 통과</em>",
        "vi": "<strong>{n}</strong> ĐƠN VỊ KIỂM TRA <em>ĐỀU ĐẠT</em> TRONG CỘT <strong>{column_position}</strong>",
        "ru": "<strong>{n}</strong> ТЕСТОВЫХ ЕДИНИЦ <em>ВСЕ ПРОШЛИ</em> В СТОЛБЦЕ <strong>{column_position}</strong>",
        "cs": "<strong>{n}</strong> TESTOVACÍCH JEDNOTEK <em>VŠECHNY PROŠLY</em> VE SLOUPCI <strong>{column_position}</strong>",
        "pl": "<strong>{n}</strong> JEDNOSTEK TESTOWYCH <em>WSZYSTKIE ZALICZONE</em> W KOLUMNIE <strong>{column_position}</strong>",
        "da": "<strong>{n}</strong> TEST ENHEDER <em>ALLE BESTÅET</em> I KOLONNE <strong>{column_position}</strong>",
        "sv": "<strong>{n}</strong> TESTENHETER <em>ALLA GODKÄNDA</em> I KOLUMN <strong>{column_position}</strong>",
        "nb": "<strong>{n}</strong> TESTENHETER <em>ALLE BESTÅTT</em> I KOLONNE <strong>{column_position}</strong>",
        "nl": "<strong>{n}</strong> TESTEENHEDEN <em>ALLEMAAL GESLAAGD</em> IN KOLOM <strong>{column_position}</strong>",
        "fi": "<strong>{n}</strong> TESTIYKSIKKÖÄ <em>KAIKKI LÄPÄISTY</em> SARAKKEESSA <strong>{column_position}</strong>",
        "is": "<strong>{n}</strong> PRÓFUNAREININGAR <em>ALLAR STAÐIST</em> Í DÁLKI <strong>{column_position}</strong>",
        "ar": "<strong>{n}</strong> وحدات اختبار <em>جميعها نجحت</em> في العمود <strong>{column_position}</strong>",
        "hi": "कॉलम <strong>{column_position}</strong> में <strong>{n}</strong> परीक्षण इकाइयाँ <em>सभी सफल</em>",
        "el": "<strong>{n}</strong> ΜΟΝΑΔΕΣ ΔΟΚΙΜΗΣ <em>ΟΛΕΣ ΕΠΙΤΥΧΕΙΣ</em> ΣΤΗ ΣΤΗΛΗ <strong>{column_position}</strong>",
    },
    "success_statement_no_column": {
        "en": "<strong>{n}</strong> TEST UNITS <em>ALL PASSED</em>",
        "fr": "<strong>{n}</strong> UNITÉS DE TEST <em>TOUTES RÉUSSIES</em>",
        "de": "<strong>{n}</strong> TESTEINHEITEN <em>ALLE BESTANDEN</em>",
        "it": "<strong>{n}</strong> UNITÀ DI TEST <em>TUTTE SUPERATE</em>",
        "es": "<strong>{n}</strong> UNIDADES DE PRUEBA <em>TODAS APROBADAS</em>",
        "pt": "<strong>{n}</strong> UNIDADES DE TESTE <em>TODAS APROVADAS</em>",
        "ro": "<strong>{n}</strong> UNITĂȚI DE TEST <em>TOATE TRECUTE</em>",
        "tr": "<strong>{n}</strong> TEST BİRİMİNİN <em>TÜMÜ GEÇTİ</em>",
        "zh-Hans": "<strong>{n}</strong> 个测试单元<em>全部通过</em>",
        "zh-Hant": "<strong>{n}</strong> 個測試單元<em>全部通過</em>",
        "ja": "<strong>{n}</strong> のテストユニットが<em>すべて合格</em>",
        "ko": "<strong>{n}</strong> 테스트 단위 <em>모두 통과</em>",
        "vi": "<strong>{n}</strong> ĐƠN VỊ KIỂM TRA <em>ĐỀU ĐẠT</em>",
        "ru": "<strong>{n}</strong> ТЕСТОВЫХ ЕДИНИЦ <em>ВСЕ ПРОШЛИ</em>",
        "cs": "<strong>{n}</strong> TESTOVACÍCH JEDNOTEK <em>VŠECHNY PROŠLY</em>",
        "pl": "<strong>{n}</strong> JEDNOSTEK TESTOWYCH <em>WSZYSTKIE ZALICZONE</em>",
        "da": "<strong>{n}</strong> TEST ENHEDER <em>ALLE BESTÅET</em>",
        "sv": "<strong>{n}</strong> TESTENHETER <em>ALLA GODKÄNDA</em>",
        "nb": "<strong>{n}</strong> TESTENHETER <em>ALLE BESTÅTT</em>",
        "nl": "<strong>{n}</strong> TESTEENHEDEN <em>ALLEMAAL GESLAAGD</em>",
        "fi": "<strong>{n}</strong> TESTIYKSIKKÖÄ <em>KAIKKI LÄPÄISTY</em>",
        "is": "<strong>{n}</strong> PRÓFUNAREININGAR <em>ALLAR STAÐIST</em>",
        "ar": "<strong>{n}</strong> وحدات اختبار <em>جميعها نجحت</em>",
        "hi": "<strong>{n}</strong> परीक्षण इकाइयाँ <em>सभी सफल</em>",
        "el": "<strong>{n}</strong> ΜΟΝΑΔΕΣ ΔΟΚΙΜΗΣ <em>ΟΛΕΣ ΕΠΙΤΥΧΕΙΣ</em>",
    },
    "preview_statement": {
        "en": "<div>PREVIEW OF TARGET TABLE:</div>",
        "fr": "<div>APERÇU DE LA TABLE CIBLE :</div>",
        "de": "<div>VORSCHAU DER ZIELTABELLE:</div>",
        "it": "<div>ANTEPRIMA DELLA TABELLA DI DESTINAZIONE:</div>",
        "es": "<div>VISTA PREVIA DE LA TABLA OBJETIVO:</div>",
        "pt": "<div>PRÉ-VISUALIZAÇÃO DA TABELA ALVO:</div>",
        "ro": "<div>PREVIZUALIZARE A TABELULUI ȚINTĂ:</div>",
        "tr": "<div>HEDEF TABLONUN ÖNİZLEMESİ:</div>",
        "zh-Hans": "<div>目标数据表预览：</div>",
        "zh-Hant": "<div>目標資料表預覽：</div>",
        "ja": "<div>ターゲットテーブルのプレビュー：</div>",
        "ko": "<div>대상 테이블 미리보기:</div>",
        "vi": "<div>XEM TRƯỚC BẢNG MỤC TIÊU:</div>",
        "ru": "<div>ПРЕДВАРИТЕЛЬНЫЙ ПРОСМОТР ЦЕЛЕВОЙ ТАБЛИЦЫ:</div>",
        "cs": "<div>NÁHLED CÍLOVÉ TABULKY:</div>",
        "pl": "<div>PODGLĄD TABELI DOCELOWEJ:</div>",
        "da": "<div>FORHÅNDSVISNING AF MÅLTABEL:</div>",
        "sv": "<div>FÖRHANDSGRANSKNING AV MÅLTABELL:</div>",
        "nb": "<div>FORHÅNDSVISNING AV MÅLTABELL:</div>",
        "nl": "<div>VOORBEELD VAN DOELTABEL:</div>",
        "fi": "<div>KOHDETAULUKON ESIKATSELU:</div>",
        "is": "<div>FORSKOÐUN Á MARKMIÐSTÖFLU:</div>",
        "ar": "<div>معاينة الجدول المستهدف:</div>",
        "hi": "<div>लक्ष्य तालिका का पूर्वावलोकन:</div>",
        "el": "<div>ΠΡΟΕΠΙΣΚΟΠΗΣΗ ΠΙΝΑΚΑ ΣΤΟΧΟΥ:</div>",
    },
    "schema_complete": {
        "en": "COMPLETE",
        "fr": "COMPLET",
        "de": "VOLLSTÄNDIG",
        "it": "COMPLETO",
        "es": "COMPLETO",
        "pt": "COMPLETO",
        "ro": "COMPLET",
        "tr": "TAM",
        "zh-Hans": "完整",
        "zh-Hant": "完整",
        "ja": "完全",
        "ko": "완전",
        "vi": "ĐẦY ĐỦ",
        "ru": "ПОЛНЫЙ",
        "cs": "ÚPLNÝ",
        "pl": "KOMPLETNY",
        "da": "KOMPLET",
        "sv": "KOMPLETT",
        "nb": "KOMPLETT",
        "nl": "VOLLEDIG",
        "fi": "TÄYDELLINEN",
        "is": "ALLT",
        "ar": "كامل",
        "hi": "पूर्ण",
        "el": "ΠΛΗΡΗΣ",
    },
    "schema_in_order": {
        "en": "IN ORDER",
        "fr": "EN ORDRE",
        "de": "IN REIHENFOLGE",
        "it": "IN ORDINE",
        "es": "EN ORDEN",
        "pt": "EM ORDEM",
        "ro": "ÎN ORDINE",
        "tr": "SIRALI",
        "zh-Hans": "有序",
        "zh-Hant": "有序",
        "ja": "順序通り",
        "ko": "순서대로",
        "vi": "ĐÚNG THỨ TỰ",
        "ru": "ПО ПОРЯДКУ",
        "cs": "V POŘADÍ",
        "pl": "W KOLEJNOŚCI",
        "da": "I RÆKKEFØLGE",
        "sv": "I ORDNING",
        "nb": "I REKKEFØLGE",
        "nl": "IN VOLGORDE",
        "fi": "JÄRJESTYKSESSÄ",
        "is": "Í RÖÐINNI",
        "ar": "بالترتيب",
        "hi": "क्रम में",
        "el": "ΜΕ ΣΕΙΡΑ",
    },
    "schema_target": {
        "en": "TARGET",
        "fr": "CIBLE",
        "de": "ZIEL",
        "it": "OBIETTIVO",
        "es": "OBJETIVO",
        "pt": "ALVO",
        "ro": "ȚINTĂ",
        "tr": "HEDEF",
        "zh-Hans": "目标",
        "zh-Hant": "目標",
        "ja": "ターゲット",
        "ko": "대상",
        "vi": "MỤC TIÊU",
        "ru": "ЦЕЛЬ",
        "cs": "CÍL",
        "pl": "CEL",
        "da": "MÅL",
        "sv": "MÅL",
        "nb": "MÅL",
        "nl": "DOEL",
        "fi": "KOHDE",
        "is": "MARKMIÐ",
        "ar": "هدف",
        "hi": "लक्ष्य",
        "el": "ΣΤΟΧΟΣ",
    },
    "schema_column": {
        "en": "COLUMN",
        "fr": "COLONNE",
        "de": "SPALTE",
        "it": "COLONNA",
        "es": "COLUMNA",
        "pt": "COLUNA",
        "ro": "COLOANĂ",
        "tr": "SÜTUN",
        "zh-Hans": "列",
        "zh-Hant": "欄位",
        "ja": "列",
        "ko": "열",
        "vi": "CỘT",
        "ru": "СТОЛБЕЦ",
        "cs": "SLOUPEC",
        "pl": "KOLUMNA",
        "da": "KOLONNE",
        "sv": "KOLUMN",
        "nb": "KOLONNE",
        "nl": "KOLOM",
        "fi": "SARAKE",
        "is": "DÁLKUR",
        "ar": "عمود",
        "hi": "स्तंभ",
        "el": "ΣΤΗΛΗ",
    },
    "schema_data_type": {
        "en": "DATA TYPE",
        "fr": "TYPE DE DONNÉES",
        "de": "DATENTYP",
        "it": "TIPO DI DATI",
        "es": "TIPO DE DATO",
        "pt": "TIPO DE DADOS",
        "ro": "TIP DE DATE",
        "tr": "VERİ TİPİ",
        "zh-Hans": "数据类型",
        "zh-Hant": "資料類型",
        "ja": "データ型",
        "ko": "데이터 유형",
        "vi": "KIỂU DỮ LIỆU",
        "ru": "ТИП ДАННЫХ",
        "cs": "DATOVÝ TYP",
        "pl": "TYP DANYCH",
        "da": "DATATYPE",
        "sv": "DATATYP",
        "nb": "DATATYPE",
        "nl": "GEGEVENSTYPE",
        "fi": "TIETOTYYPPI",
        "is": "GAGNATAG",
        "ar": "نوع البيانات",
        "hi": "डेटा प्रकार",
        "el": "ΤΥΠΟΣ ΔΕΔΟΜΕΝΩΝ",
    },
    "schema_expected": {
        "en": "EXPECTED",
        "fr": "ATTENDU",
        "de": "ERWARTET",
        "it": "PREVISTO",
        "es": "ESPERADO",
        "pt": "ESPERADO",
        "ro": "AȘTEPTAT",
        "tr": "BEKLENEN",
        "zh-Hans": "预期",
        "zh-Hant": "預期",
        "ja": "予想",
        "ko": "예상",
        "vi": "KỲ VỌNG",
        "ru": "ОЖИДАЕМОЕ",
        "cs": "OČEKÁVANÝ",
        "pl": "OCZEKIWANY",
        "da": "FORVENTET",
        "sv": "FÖRVÄNTAT",
        "nb": "FORVENTET",
        "nl": "VERWACHT",
        "fi": "ODOTETTU",
        "is": "VÆNTANLEGT",
        "ar": "متوقع",
        "hi": "अपेक्षित",
        "el": "ΑΝΑΜΕΝΟΜΕΝΟ",
    },
    "column_schema_match_str": {
        "en": "COLUMN SCHEMA MATCH",
        "fr": "CORRESPONDANCE DU SCHÉMA DE COLONNE",
        "de": "ÜBEREINSTIMMUNG DES SPALTENSCHEMAS",
        "it": "CORRISPONDENZA DELLO SCHEMA DI COLONNA",
        "es": "COINCIDENCIA DEL ESQUEMA DE COLUMNA",
        "pt": "CORRESPONDÊNCIA DO ESQUEMA DE COLUNA",
        "ro": "POTRIVIRE A SCHEMEI DE COLOANĂ",
        "tr": "SÜTUN ŞEMASI EŞLEŞMESI",
        "zh-Hans": "列模式匹配",
        "zh-Hant": "欄位綱要匹配",
        "ja": "列スキーマ一致",
        "ko": "열 스키마 일치",
        "vi": "KHỚP LƯỢC ĐỒ CỘT",
        "ru": "СООТВЕТСТВИЕ СХЕМЫ СТОЛБЦА",
        "cs": "SHODA SCHÉMATU SLOUPCE",
        "pl": "ZGODNOŚĆ SCHEMATU KOLUMNY",
        "da": "KOLONNESKEM MATCH",
        "sv": "KOLUMNSCHEMA MATCHNING",
        "nb": "KOLONNESKJEMA SAMSVAR",
        "nl": "KOLOMSCHEMA OVEREENKOMST",
        "fi": "SARAKESKEEMAN VASTAAVUUS",
        "is": "DÁLKASKEMA SAMSVÖRUN",
        "ar": "تطابق مخطط العمود",
        "hi": "स्तंभ स्कीमा मिलान",
        "el": "ΑΝΤΙΣΤΟΙΧΙΑ ΣΧΗΜΑΤΟΣ ΣΤΗΛΗΣ",
    },
    "supplied_column_schema": {
        "en": "Supplied Column Schema:",
        "fr": "Schéma de Colonne Fourni :",
        "de": "Bereitgestelltes Spaltenschema:",
        "it": "Schema di Colonna Fornito:",
        "es": "Esquema de Columna Suministrado:",
        "pt": "Esquema de Coluna Fornecido:",
        "ro": "Schema de Coloană Furnizată:",
        "tr": "Sağlanan Sütun Şeması:",
        "zh-Hans": "提供的列模式：",
        "zh-Hant": "提供的欄位綱要：",
        "ja": "提供された列スキーマ：",
        "ko": "제공된 열 스키마:",
        "vi": "Lược Đồ Cột Được Cung Cấp:",
        "ru": "Предоставленная Схема Столбца:",
        "cs": "Dodané Schéma Sloupce:",
        "pl": "Dostarczony Schemat Kolumny:",
        "da": "Angivet Kolonneskema:",
        "sv": "Tillhandahållet Kolumnschema:",
        "nb": "Angitt Kolonneskjema:",
        "nl": "Geleverd Kolomschema:",
        "fi": "Annettu Sarakeskeema:",
        "is": "Uppgefið Dálkaskema:",
        "ar": "مخطط العمود المقدم:",
        "hi": "प्रदान किया गया स्तंभ स्कीमा:",
        "el": "Παρεχόμενο Σχήμα Στήλης:",
    },
}
